// Copyright  2006-2009 Travis Robinson. All rights reserved.
// 
// website: sourceforge.net/projects/libusbdotnet/
// e-mail:  libusbdotnet@gmail.com
// 
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. or 
// visit www.gnu.org.
// 
// 
using System;
using LibUsbDotNet.Descriptors;
using LibUsbDotNet.Internal;

namespace LibUsbDotNet.Info
{
    /// <summary> Contains Endpoint information for the current <see cref="T:LibUsbDotNet.Info.UsbConfigInfo"/>.
    /// </summary> 
    public class UsbEndpointInfo : UsbBaseInfo
    {
        internal UsbEndpointDescriptor mUsbEndpointDescriptor;

        internal UsbEndpointInfo(byte[] descriptor)
        {
            mUsbEndpointDescriptor = new UsbEndpointDescriptor();
            Helper.BytesToObject(descriptor, 0, Math.Min(UsbEndpointDescriptor.Size, descriptor[0]), mUsbEndpointDescriptor);
        }

        /// <summary>
        /// Gets the <see cref="UsbEndpointDescriptor"/> information.
        /// </summary>
        public UsbEndpointDescriptor Descriptor
        {
            get
            {
                return mUsbEndpointDescriptor;
            }
        }

        ///<summary>
        ///Returns a <see cref="T:System.String"></see> that represents the current <see cref="UsbEndpointInfo"></see>.
        ///</summary>
        ///
        ///<returns>
        ///A <see cref="System.String"></see> that represents the current <see cref="UsbEndpointInfo"></see>.
        ///</returns>
        public override string ToString()
        {
            return Descriptor.ToString();
        }
    }
}