﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;
using System.IO.Ports;

namespace Prox_ESC_POS_Printer
{
    public class Printer_Auxiliary_Functions : IPrinter_Auxiliary
    {
        Printer_Method Printer_Method_In_Auxiliary_Functions;
        
        /// <summary>
        /// 建構式 Printer_Auxiliary_Functions 開啟USB or Serial Port
        /// </summary>
        //public Printer_Auxiliary_Functions()
        //{
        //    if (Printer_Device.Usb_or_serial)
        //    {
        //        Printer_Method_In_Auxiliary_Functions = new Printer_Method((LibUsbRegistry)Printer_Device.UsbPort1Registry,Printer_Device.EndpointWriter,Printer_Device.EndpointRead);
        //    }
        //    else
        //    {
        //        Printer_Method_In_Auxiliary_Functions = new Printer_Method(Printer_Device.Serialport);
        //    }
        //}

        public Printer_Auxiliary_Functions(SerialPort x)
        {
            Printer_Method_In_Auxiliary_Functions = new Printer_Method(x);
        }
        public Printer_Auxiliary_Functions(UsbRegistry x,UsbEndpointWriter Write,UsbEndpointReader Read)
        {
                Printer_Method_In_Auxiliary_Functions = new Printer_Method((LibUsbRegistry)x,Write, Read);
        }



        /// <summary>
        /// 剪紙
        /// </summary>
        public void Printer_Paper_Cut()
        {
            Printer_Method_In_Auxiliary_Functions.Paper_Cut_Position_Feed(0);
        }

        /// <summary>
        /// 多載剪紙
        /// </summary>
        /// <param name="x"></param> 剪紙狀態設定
        public void Printer_Paper_Cut(Printer_Status.Printer_Auxiliary_Status x)
        {
            Printer_Method_In_Auxiliary_Functions.Paper_Cut_Position_Feed(x.Set_Printer_Paper_Cut_Position_Feed.Get_Position, x.Set_Printer_Paper_Cut_Position_Feed.Space);

        }

        /// <summary>
        /// 測試列印
        /// </summary>
        public void Printer_Test_Print()
        {
            Printer_Method_In_Auxiliary_Functions.Test_Print();
        }


        /// <summary>
        /// Printer 初始化
        /// </summary>
        public void Printer_Initialize()
        {
            Printer_Method_In_Auxiliary_Functions.Printer_Initialize();
        }

        /// <summary>
        /// 硬體 Reset
        /// </summary>
        public void Printer_Hardware_Reset()
        {
            Printer_Method_In_Auxiliary_Functions.Hardware_Reset();
        }

        /// <summary>
        /// Flash Memory Release
        /// </summary>
        public void Printer_Extension_Memory_Initialize()
        {
            Printer_Method_In_Auxiliary_Functions.Extension_Memory_Initialize();
        }

        /// <summary>
        /// Function setting 硬體出錯時適用
        /// </summary>
        public void Printer_Function_Settings()
        {

            byte[] sw1 = new byte[1] { 0xE6 };
            byte[] sw2 = new byte[1] { 0xFF };
            byte[] sw3 = new byte[1] { 0xC1 };
            byte[] sw4 = new byte[1] { 0x64 };
            byte[] sw5 = new byte[1] { 0xF6 };
            byte[] sw6 = new byte[1] { 0x00 };
            byte[] sw7 = new byte[1] { 0x00 };
            byte[] sw8 = new byte[1] { 0x00 };
            byte[] sw9 = new byte[1] { 0x00 };
            byte[] sw10 = new byte[1] { 0x01 };
            byte[] sw11 = new byte[1] { 0xF4 };


            Printer_Method_In_Auxiliary_Functions.Function_Settings(1 + 128,sw1);
            Printer_Method_In_Auxiliary_Functions.Function_Settings(2 + 128, sw2);
            Printer_Method_In_Auxiliary_Functions.Function_Settings(3 + 128, sw3);
            Printer_Method_In_Auxiliary_Functions.Function_Settings(4 + 128, sw4);
            Printer_Method_In_Auxiliary_Functions.Function_Settings(5 + 128, sw5);
        }

        /// <summary>
        /// forward base on dot
        /// </summary>
        /// <param name="x"></param>x dot
        public void Printer_Print_and_Feed_Forward(int x)
        {
            Printer_Method_In_Auxiliary_Functions.Print_and_Feed_Forward(x);
        }

        /// <summary>
        /// forward base on n line
        /// </summary>
        /// <param name="x"></param>x line
        public void Printer_Print_and_n_Lines_Feed_Forward(int x)
        {
            Printer_Method_In_Auxiliary_Functions.Print_and_n_Lines_Feed_Forward(x);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="x"></param>
        public void Printer_Automatic_Status_Back_EnableDisable(int n)
        {
            switch(n)
            {
                case 0:
                    {
                        Printer_Method_In_Auxiliary_Functions.Automatic_Status_Back_EnableDisable(0);
                        break;
                    
                    }
                case 1:
                    {
                        Printer_Method_In_Auxiliary_Functions.Automatic_Status_Back_EnableDisable(31);
                        break;
                    }
                default:
                    {
                        break;
                    }
            

            }
        }
    }
}
