﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;
using System.Drawing;
using System.IO.Ports;

namespace Prox_ESC_POS_Printer
{
    public class Printer_Barcode:IPrinter_Barcode
    {
        /// <summary>
        /// Printer_Image 建構式
        /// </summary>
        Printer_Method Printer_Method_In_Printer_Barcode;

        public Printer_Barcode(SerialPort x)
        {
            Printer_Method_In_Printer_Barcode = new Printer_Method(x);
        }
        public Printer_Barcode(UsbRegistry x, UsbEndpointWriter Write, UsbEndpointReader Read)
        {
            Printer_Method_In_Printer_Barcode = new Printer_Method((LibUsbRegistry)x, Write, Read);
        }



        public void Printer_Barcode_Print(Printer_Status.Printer_Barcode_Status x,string barcode_string)
        {
            Printer_Barcode_Status_Set(x);
            
            Printer_Method_In_Printer_Barcode.Barcode_Print((int)x.Barcode_Style, barcode_string);
        }


        private int Barcode_System = (int)Printer_Status.Printer_Barcode_Status.Barcode_System.CODE39;
        public void Printer_Barcode_Print( string barcode_string)
        {
            Printer_Method_In_Printer_Barcode.Barcode_Print(Barcode_System, barcode_string);
        }
        
        public void Printer_Barcode_Status_Set(Printer_Status.Printer_Barcode_Status status)
        {

            Barcode_System = (int)status.Barcode_Style;
            Printer_Method_In_Printer_Barcode.HRI_Character_Print_Position_Selection((int)status.Position);
            Printer_Method_In_Printer_Barcode.Barcode_Height_Set(status.Barcode_Height_Set);
            Printer_Method_In_Printer_Barcode.Barcode_Horizontal_Size_Set(status.Barcode_Horizontal_Size_Set);
            Printer_Method_In_Printer_Barcode.Alignment((int)status.Alignment);
        }
    }
}
