﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;


using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;


namespace Prox_ESC_POS_Printer
{
    /// <summary>
    /// Printer_Event 類別
    /// </summary>
    public class Printer_Event:IPrinter_Event
    {
        public Printer_Event(SerialPort s)
        {
            this.SerialPort1 = s;
        }
        public Printer_Event(UsbRegistry s, UsbEndpointWriter Write, UsbEndpointReader Read)
        {
            this.UsbRegistry1 = s;
            this.Write1 = Write;
            this.Read1 = Read;
        }
        SerialPort SerialPort1;

        UsbEndpointWriter Write1;
        UsbEndpointReader Read1;
        UsbRegistry UsbRegistry1;
        /// <summary>
        /// 事件委派型別
        /// </summary>
        /// <param name="s"></param>
        /// <param name="e"></param>
        public delegate void String_Hander(object s, Printer_Receive e);

        /// <summary>
        /// Automatic_Status_Back 事件
        /// </summary>
        public event String_Hander Automatic_Status_Back;

        /// <summary>
        /// serial port 資料接收
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void SerialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                

                string receive = null;
                receive = SerialPort1.ReadExisting();
                char[] a = receive.ToCharArray();
                if (receive.Length != 0)
                {
                    Wait_For_All_Data(receive);
                }
            }
            catch
            {

            }
        }

        /// <summary>
        /// USB 資料接收
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void USB_Read_DataReceived(object sender, LibUsbDotNet.Main.EndpointDataEventArgs e)
        {
            try
            {
                string receive = null;
                receive = Encoding.Default.GetString(e.Buffer, 0, e.Count);
                if (receive.Length != 0)
                {
                    Wait_For_All_Data(receive);
                }
            }
            catch
            {

            }
        }

        /// <summary>
        /// 等待資料完整
        /// </summary>
        /// <param name="txt"></param>
         string receive_txt="";
        private void Wait_For_All_Data(string txt)
        {
            
            receive_txt += txt;
            if (receive_txt.Length >= 4)
            {
                Automatic_Status_Back(this,new Printer_Receive(txt));
                receive_txt = "";
            }

        }
    }

    /// <summary>
    /// Printer_Receive 類別
    /// </summary>
    public class Printer_Receive : EventArgs
    {
        private string now_string = "";
        public Printer_Receive(string now_string)
        {
            this.now_string = now_string;

        }
        public string Get_string
        {
            get { return now_string; }
            set { now_string = value; }
        }
    }
}
