﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;
using System.Drawing;
using System.IO.Ports;


namespace Prox_ESC_POS_Printer
{

    /// <summary>
    /// Printer_Image 類別
    /// </summary>
    public class Printer_Image:IPrinter_Image
    {

        /// <summary>
        /// Printer_Image 建構式
        /// </summary>
        Printer_Method Printer_Method_In_Printer_Image;

        public Printer_Image(SerialPort x)
        {
            Printer_Method_In_Printer_Image = new Printer_Method(x);
        }
        public Printer_Image(UsbRegistry x, UsbEndpointWriter Write, UsbEndpointReader Read)
        {
            Printer_Method_In_Printer_Image = new Printer_Method((LibUsbRegistry)x, Write, Read);
        }

        /// <summary>
        /// 上傳圖片
        /// </summary>
        /// <param name="image"></param>
        public void Printer_Upload_Image(Bitmap image)
        {
            Printer_Method_In_Printer_Image.Downloaded_Bit_Image_Registration(image);
        }

        /// <summary>
        /// 列印圖片
        /// </summary>
        /// <param name="status"></param>Printer_Status.Printer_Image_Status 類別 設定圖片
        public void Printer_Image_Print(Printer_Status.Printer_Image_Status status)
        {
            Printer_Method_In_Printer_Image.Print_Density_Specify(status.Density);

            if (status.Image_Position.Space)
            {
                Printer_Method_In_Printer_Image.Bit_Image_Print(status.Image_Position.Get_Position, status.Image_Position.Left_Space);

            }
            else
            {
                Printer_Method_In_Printer_Image.Downloaded_Bit_Image_Print(status.Image_Position.Get_Position);
        
            }
        }

        /// <summary>
        /// 上傳圖片至Flash 
        /// </summary>
        /// <param name="image"></param>圖片陣列
        public void Printer_Upload_NV_Image(Bitmap[] image)
        {
            Printer_Method_In_Printer_Image.NV_Bit_Image_Define(image);
        }

        /// <summary>
        /// 列印Flash中圖片
        /// </summary>
        /// <param name="status"></param>Printer_Status.Printer_Image_Status 類別 設定圖片
        public void Printer_NV_Image_Print(Printer_Status.Printer_Image_Status status)
        {
            Printer_Method_In_Printer_Image.Print_Density_Specify(status.Density);

            if (status.Image_Position.Space)
            {
                Printer_Method_In_Printer_Image.NV_Bit_Image_Selection(status.Image_Position.Select,status.Image_Position.Get_Position, status.Image_Position.Left_Space);
            }
            else
            {
                Printer_Method_In_Printer_Image.NV_Bit_Image_Print(status.Image_Position.Select, status.Image_Position.Get_Position);

            }
        }

    }
}
