﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;
using System.Drawing;


namespace Prox_ESC_POS_Printer
{
    interface IPrinter_Device
    {
        //void Init_Serial_Port();
        //void Init_Local_Usb();
        void Serial_Port_Open();
        void Usb_Port_Open();


    }
    interface IPrinter_Status
    {
        //void Printer_String_Status_Init();
    }
    interface IPrinter_Event
    {
        void SerialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e);
        void USB_Read_DataReceived(object sender, LibUsbDotNet.Main.EndpointDataEventArgs e);

    }

    interface IPrinter_String
    {
        void Printer_String_Initialize();
        void Printer_Write(string txt);
        void Printer_String_Print(string txt);
        void Printer_String_Status_Set(Printer_Status.Printer_String_Status x);
        void Printer_String_Print(Printer_Status.Printer_String_Status x, string txt);
        void Printer_Special_String_Print(Printer_Status.Printer_String_Status x,Font font, string txt);
    }

    interface IPrinter_Auxiliary
    {
        void Printer_Paper_Cut();
        void Printer_Paper_Cut(Printer_Status.Printer_Auxiliary_Status x);
        void Printer_Test_Print();
        void Printer_Initialize();
        void Printer_Hardware_Reset();
        void Printer_Extension_Memory_Initialize();
        void Printer_Function_Settings();
        void Printer_Print_and_Feed_Forward(int x);
        void Printer_Print_and_n_Lines_Feed_Forward(int x);

    }


    interface IPrinter_Image
    {
        void Printer_Upload_Image(Bitmap image);
        void Printer_Image_Print(Printer_Status.Printer_Image_Status status);
        void Printer_Upload_NV_Image(Bitmap[] image);
        void Printer_NV_Image_Print(Printer_Status.Printer_Image_Status status);

    }

    interface IPrinter_Barcode
    {
        void Printer_Barcode_Print(Printer_Status.Printer_Barcode_Status x, string barcode_string);
        void Printer_Barcode_Print(string barcode_string);
        void Printer_Barcode_Status_Set(Printer_Status.Printer_Barcode_Status status);

    }

}
