﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prox_ESC_POS_Printer
{
    public class Printer_Status : IPrinter_Status
    {
        public Printer_Status()
        {

        }

        /// <summary>
        /// Printer_Auxiliary_Status 類別
        /// </summary>
        public class Printer_Auxiliary_Status
        {
            public Printer_Auxiliary_Status()
            {

            }

            /// <summary>
            /// 設定剪紙狀態
            /// </summary>
            Set_Printer_Paper_Cut_Position_Feed set_printer_paper_cut_position_feed=new Set_Printer_Paper_Cut_Position_Feed();
            public Set_Printer_Paper_Cut_Position_Feed Set_Printer_Paper_Cut_Position_Feed
            {
                get
                {
                    return set_printer_paper_cut_position_feed;
                }
                set
                {
                    set_printer_paper_cut_position_feed = value;
                }
            }
        }

        /// <summary>
        /// Printer_String_Status 類別 設定文字狀態
        /// </summary>
        public class Printer_String_Status
        {
            public Printer_String_Status()
            {
                //Printer_String_Status_init();
            }

            public void Printer_String_Status_init()
            {
                font = true;
                
                string_set.X = 0;
                string_set.Y = 0;

                underline = false;
                bold = false;
                double_strike = false;
                rotate = false;
                flip = false;
                reverse = false;
                alignment.Align_left = true;
                space = 0;
                up_down_dots = 10;
                left_margin_set = 0;

            }


            /// <summary>
            /// true=24X12 false=12X6
            /// </summary>
            bool font = true;
            public bool FontA
            {
                get
                {
                    return font;
                }
                set
                {
                    font = value;
                }
            }

            /// <summary>
            /// set string size
            /// </summary>
            Set_X_And_Y string_set = new Set_X_And_Y(0, 0);
            public Set_X_And_Y String_Set
            {
                get
                {
                    return string_set;
                }
                set
                {
                    string_set = value;
                }
            }

            /// <summary>
            /// underline set
            /// </summary>
            bool underline = false;
            public bool Underline
            {
                get
                {
                    return underline;
                }
                set
                {
                    underline = value;
                }
            }

            /// <summary>
            /// bold set
            /// </summary>
            bool bold = false;
            public bool Bold
            {
                get
                {
                    return bold;
                }
                set
                {
                    bold = value;
                }
            }

            /// <summary>
            /// double_strike set
            /// </summary>
            bool double_strike = false;
            public bool Double_Strike
            {
                get
                {
                    return double_strike;
                }
                set
                {

                    double_strike = value;
                }
            }

            /// <summary>
            /// rotate set
            /// </summary>
            bool rotate = false;
            public bool Rotate
            {
                get
                {
                    return rotate;
                }
                set
                {

                    rotate = value;
                }
            }

            /// <summary>
            /// flip set
            /// </summary>
            bool flip = false;
            public bool Flip
            {
                get
                {
                    return flip;
                }
                set
                {

                    flip = value;
                }
            }

            /// <summary>
            /// reverse set
            /// </summary>
            bool reverse = false;
            public bool Reverse
            {
                get
                {
                    return reverse;
                }
                set
                {

                    reverse = value;
                }
            }

            /// <summary>
            /// alignment set 1.left 2.center 3.right
            /// </summary>
            Set_Alignment alignment = new Set_Alignment(0);
            public Set_Alignment String_Alignment
            {
                get
                {
                    return alignment;
                }
                set
                {
                    alignment = value;
                }
            }

            /// <summary>
            /// the space between word and word
            /// </summary>
            int space = 0;
            public int Space
            {
                get
                {
                    return space;
                }
                set
                {

                    space = value;
                }
            }

            /// <summary>
            /// density set
            /// </summary>
            int density = 100;
            public int Density
            {
                get
                {
                    return density;
                }
                set
                {
                    if (value >= 60 && value <= 140)
                    {
                        density = value;
                    }
                    else
                    {
                        density = 100;         
                    }

                }
            }

            /// <summary>
            /// the space between up and down word
            /// </summary>
            int up_down_dots = 10;
            public int Up_Down_Dots
            {
                get
                {
                    return up_down_dots;
                }
                set
                {
                    up_down_dots = value;
                }
            }

            /// <summary>
            /// left margin set
            /// </summary>
            int left_margin_set=0;
            public int Left_Margin_Set
            {
                get
                {
                    return left_margin_set;
                }
                set
                {
                    left_margin_set=value;
                }
            }

        }

        /// <summary>
        /// Printer_Image_Status 類別 設定圖片狀態
        /// </summary>
        public class Printer_Image_Status
        {
            public Printer_Image_Status()
            {
                Printer_Image_Status_init();
            }

            public void Printer_Image_Status_init()
            {
                density = 100;
                image_position.Normal_Mode_Printing = true;
                image_position.Left_Space = 0;
            }


            int density = 100;
            public int Density
            {
                get
                {
                    return density;
                }
                set
                {
                    if (value >= 60 && value <= 140)
                    {
                        density = value;
                    }
                    else
                    {
                        density = 100;
                    }

                }
            }

            /// <summary>
            /// 圖片狀態設定
            /// </summary>
            Image_Position image_position=new Image_Position();
            public Image_Position Image_Position
            {
                get
                {
                    return image_position;
                }
                set
                {
                    image_position = value;
                }
            }

        }

        /// <summary>
        /// Printer_Barcode_Status 類別 設定條碼狀態
        /// </summary>
        public class Printer_Barcode_Status
        {
            public Printer_Barcode_Status()
            {
                
            }

            public void Printer_Barcode_Status_init()
            {
                
            }




            public enum Character_Position : int
            {
                Do_Not_Print=0,
                Over_Barcode=1,
                Under_Barcode=2,
                Over_And_Under_Barcode=3

            }

            public enum Barcode_System : int
            {
                UPC_A=0,
                UPC_E=1,
                JAN13=2,
                JAN8=3,
                CODE39=4,
                ITF=5,
                CODABAR=6,

            }

            public enum Barcode_Alignment : int
            {
                Left=0,
                Center=1,
                Right=2
                
            }

            Character_Position position=Character_Position.Do_Not_Print;
            public Character_Position Position
            {
                get
                {
                    return position;
                }
                set
                {
                    position = value;
                }
            }

            Barcode_System barcode_style=Barcode_System.CODE39;
            public Barcode_System Barcode_Style
            {
                get
                {
                    return barcode_style;
                }
                set
                {
                    barcode_style = value;
                }
            }

            Barcode_Alignment alignment = Barcode_Alignment.Left;
            public Barcode_Alignment Alignment
            {
                get
                {
                    return alignment;
                }
                set
                {
                    alignment = value;
                }
            }

            int barcode_height_set;
            public int Barcode_Height_Set
            {
                get
                {
                    return barcode_height_set;
                }
                set
                {
                    barcode_height_set = value;
                }
            }

            int barcode_horizontal_size_set;
            public int Barcode_Horizontal_Size_Set
            {
                get 
                {
                    return barcode_horizontal_size_set;

                }
                set 
                {
                    barcode_horizontal_size_set=value;
                }
            }

        }

    }
    public class Set_X_And_Y
    {
        private int x = 0;
        private int y = 0;
        public Set_X_And_Y()
        {
            this.x = 0;
            this.y = 0;
        }
        public Set_X_And_Y(int x, int y)
        {
            this.x = x;
            this.y = y;

        }
        public int X
        {
            get { return x; }
            set { x = value; }
        }
        public int Y
        {
            get { return y; }
            set { y = value; }

        }

    }
    public class Set_Alignment
    {
        private int alignment = 0;
        
        public Set_Alignment(int x)
        {
            
            this.alignment = x;
        }
        public int Get_Alignment()
        {
            return alignment;
        }
        public bool Align_left
        {
            get
            {
                if (alignment == 0)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 0;
                }
                else
                {
                    alignment = 1;
                }
            }
        }
        public bool Centered
        {
            get
            {
                if (alignment == 1)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 1;
                }
                else
                {
                    alignment = 0;
                }

            }

        }
        public bool Align_right
        {
            get
            {
                if (alignment == 2)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 2;
                }
                else
                {
                    alignment = 0;
                }

            }
            
        }
        

    }
    public class Image_Position
    {
        public Image_Position()
        {
            this.space = false;
        }

        /// <summary>
        /// left space has specified
        /// </summary>
        /// <param name="space"></param>
        public Image_Position(bool space,int left_space)
        {
            this.space = space;
            this.left_space = left_space;
        }

        bool space;
        public bool Space
        {
            get
            {
                return space;
            }
            set
            {
                space = value;
            
            }

        }

        int select=1;
        public int Select
        {
            get
            {
                return select;
            }
            set
            {
                select = value;
            }
        }


        int position = 0;
        public int Get_Position
        {
            get
            {
                return position;
            }
        }

        int left_space=0;
        public int Left_Space
        {
            get
            {
                return left_space;
            }
            set
            {
                if (value > 0)
                {
                    if (position < 4)
                    {
                        position += 4;
                    }
                    space = true;
                }
                else
                {
                    if (position > 4)
                    {
                        position -= 4;
                    }

                    space = false;
                }



                left_space = value;
            }
        }

        public bool Normal_Mode_Printing
        {
            get
            {
                if (position == 0 || position == 4)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            set
            {
                if (value)
                {
                    if (space)
                    {
                        position = 4;
                    }
                    else
                    {
                        position = 0;
                    }
                }
                else
                {
                    if (space)
                    {
                        position = 5;
                    }
                    else
                    {
                        position = 1;
                    }
                }
            }
        }

        public bool Double_Width_Mode_Printing
        {
            get
            {
                if (position == 1 || position == 5)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            set
            {
                if (value)
                {
                    if (space)
                    {
                        position = 5;
                    }
                    else
                    {
                        position = 1;
                    }
                }
                else
                {
                    if (space)
                    {
                        position = 4;
                    }
                    else
                    {
                        position = 0;
                    }
                }
            }
        }

        public bool Double_Height_Mode_Printing
        {
            get
            {
                if (position == 2 || position == 6)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            set
            {
                if (value)
                {
                    if (space)
                    {
                        position = 6;
                    }
                    else
                    {
                        position = 2;
                    }
                }
                else
                {
                    if (space)
                    {
                        position = 4;
                    }
                    else
                    {
                        position = 0;
                    }
                }
            }
        }

        public bool Double_Height_And_Width_Mode_Printing
        {
            get
            {
                if (position == 3 || position == 7)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            set
            {
                if (value)
                {
                    if (space)
                    {
                        position = 7;
                    }
                    else
                    {
                        position = 3;
                    }
                }
                else
                {
                    if (space)
                    {
                        position = 4;
                    }
                    else
                    {
                        position = 0;
                    }
                }
            }
        }
    }
    public class Set_Printer_Paper_Cut_Position_Feed
    {
        bool set_space=false;

        //int position=0;
        public int Get_Position
        {
            get
            {
                if (set_space)
                {
                    if (full_cut)
                    {
                        return 65;
                    }
                    else
                    {
                        return 66;
                    }
                }
                else
                {
                    if (full_cut)
                    {
                        return 0;
                    }
                    else
                    {
                        return 1;
                    }
                }
            }
        }


        int space;
        public int Space
        {
            get 
            {
                return space;
            }
            set
            {
                if (value > 0)
                {
                    set_space = true;

                }
                else
                {
                    set_space = false;

                }
                space = value;
            }
        }



        bool full_cut=true;
        public bool Full_Cut
        {
            get
            {
               return full_cut;
            }
            set
            {
                full_cut = value;
            }
        }
    }
}
