﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.IO;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Collections;
using System.Drawing.Text;


using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;


namespace printer_test
{
    
    public class Class1
    {



        /// <summary>
        /// 事件與委派
        /// </summary>
        public delegate void string_hander(object s, stringeventargs e);
        //
        public event string_hander evt_receivechar;


        //protected virtual void do_transmission(stringeventargs e)
        //{

        //    string_hander handler = evt_receivechar;

        //    if (handler != null)
        //    {
        //        handler(this, e);
        //    }

        //}
        /// <summary>
        /// 20091111修改委派
        /// </summary>
        /// <param name="receive"></param>
        public void do_transmission(string receive)
        {
            evt_receivechar(this, new stringeventargs(receive));
        }

        /// <summary>
        /// serial
        /// </summary>
        static bool usb_or_serial = true;
        static public bool Usb_or_serial
        {
            set { usb_or_serial = value; }
            get { return usb_or_serial; }
        }

        static SerialPort serialPort1 = new SerialPort();
        static public SerialPort Serialport
        {
            set { serialPort1 = value; }
            get { return serialPort1; }
        }

        static UsbDevice local_usb;
        static public UsbDevice Local_usb
        {
            set { local_usb = value; }
            get { return local_usb; }

        }


        static UsbRegistry device_reg_current;
        static public UsbRegistry Device_reg_current
        {
            set { device_reg_current = value; }
            get { return device_reg_current; }
           
        }

        //public static UsbRegDeviceList usb_device_list;
        public static UsbEndpointList endpoint_list = null;
        public static UsbEndpointWriter write = null;
        public static UsbEndpointReader read = null;

        
        

        public void Init_serialport()
        {
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived);
        }

        public void Init_local_usbport()
        {
            byte bCfgValue;

            bool bRtn = Class1.Device_reg_current.Device.GetConfiguration(out bCfgValue);
            if (bRtn)
            {
                if (bCfgValue != 1)
                {
                    Class1.Device_reg_current.Device.SetConfiguration(1);
                }
                else
                {
                    Class1.Device_reg_current.Device.SetConfiguration(0);
                    Class1.Device_reg_current.Device.SetConfiguration(1);
                }

                if (Class1.Device_reg_current.Device is LibUsbDevice) bRtn = ((LibUsbDevice)Class1.Device_reg_current.Device).ClaimInterface(0);
            }


            
            write = Device_reg_current.Device.OpenEndpointWriter(WriteEndpointID.Ep01);
            read=Device_reg_current.Device.OpenEndpointReader(ReadEndpointID.Ep02);
            read.DataReceived += new EventHandler<EndpointDataEventArgs>(read_DataReceived);
            read.DataReceivedEnabled = true;
        }

        void read_DataReceived(object sender, EndpointDataEventArgs e)
        {
            try
            {
                string receive = null;
                receive = Encoding.Default.GetString(e.Buffer, 0, e.Count);
                char[] re = receive.ToCharArray();
                //do_transmission(new stringeventargs(receive));
                if (receive != "")
                {
                    do_transmission(receive);
                }


            }
            catch
            {

            }
        }
        
        void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {  
            try
            {
                
               
                string receive = null;
                receive = serialPort1.ReadExisting();
                char[] re = receive.ToCharArray();
                //do_transmission(new stringeventargs(receive));
                 do_transmission(receive);
                

            }
            catch
            {
                
            }
        }

        /// <summary>
        /// Printing Command
        /// </summary>
        /// 


        public void Line_Feed()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1A }, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x0A }, 0, 1);
                }
            }

            
        }

        public void Marked_Paper_Print_and_Form_Feed()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x0C }, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x0C }, 0, 1);
                }
            }

            
        }

        public void Page_Mode_Data_Print()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x0C }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x0C }, 0, 2);
                }
            }

            
        }

        public void Print_and_Feed_Forward(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x4A, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x4A, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Print_and_n_Lines_Feed_Forward(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x64, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x64, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        public void Print_Data_Cancel_in_Page_Mode()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x18}, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x18 }, 0, 1);
                }
            }

            
        }

        /// <summary>
        /// Line Spacing
        /// </summary>
        /// <param name="x"></param>

        public void Line_Spacing_init(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x32 }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x32 }, 0, 2);
                }
            }
        }

        public void Line_Spacing_Set(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x33, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x33, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        /// <summary>
        /// Character Set
        /// </summary>
        /// <param name="x"></param>
        /// 

        public void Character_Right_Space_Amount_Set(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x20, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x20, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        public void Print_Mode_Select(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x21, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x21, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        public void Character_Font_Select(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x4D, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x4D, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Character_Size_Specify(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1D, 0x21, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x21, Convert.ToByte(x) }, 0, 3);
                }
            }


            
        }

        public void Underline_Settings(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x2D, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x2D, Convert.ToByte(x) }, 0, 3);
                }
            }


           
        }

        public void Bold_Print_SpecifyCancel(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x45, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x45, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Double_Strike_Printing_SpecifyCancel(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x74, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x74, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Character_Right_Rotate_SpecifyCancel(int x)
        {

            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1B, 0x56, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x56, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }
        
        public void Inversion_Printing_SpecifyCancel(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x7B, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x7B, Convert.ToByte(x) }, 0, 3);
                }
            }

           
        }

        public void Reverse_Print_SpecifyCancel(int x)
        {

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x42, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x42, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        public void International_Character_Select(int x)
        {

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x52, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x52, Convert.ToByte(x) }, 0, 3);
                }
            }

           
        }

        public void Character_Code_Table_Select(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x74, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x74, Convert.ToByte(x) }, 0, 3);
                }
            }

           
        }

        public void Downloaded_Character_Registration(int fontsize,string character)
        {
            ArrayList to_byte=String_conv_to_byte(character);
            byte[] data=new byte[to_byte.Count];
            for (int i = 0; i < to_byte.Count; i++)
            {
                data[i] = Convert.ToByte(to_byte[i]);
            }

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x26, Convert.ToByte(fontsize), 0x20, Convert.ToByte(Convert.ToInt16(0x20) + Convert.ToInt16((int)to_byte[to_byte.Count - 1] - 1)) }, 0, 5, 1000, out bytesWritten);
                    write.Write(data, 0, data.Length - 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x26, Convert.ToByte(fontsize), 0x20, Convert.ToByte(Convert.ToInt16(0x20) + Convert.ToInt16((int)to_byte[to_byte.Count - 1] - 1)) }, 0, 5);

                    serialPort1.Write(data, 0, data.Length - 1);
                }
            }



            
        }
        public ArrayList String_conv_to_byte(string character)
        {
            int character_length = character.Length;
            ArrayList all_character = new ArrayList();
            for(int i=0;i<character_length;i++ )
            {
                ArrayList k = One_string_conv_to_byte(character[i].ToString());
                for (int j = 0; j < k.Count; j++)
                {
                    all_character.Add(k[j]);
                }
            }
            all_character.Add(character_length);
            return all_character;
        }

        public static FontFamily[] fontFamilies;
        public static FontFamily[] privatefontFamilies;
        public static int fontindex;

        public ArrayList One_string_conv_to_byte(string character)
        {
            Bitmap img = new Bitmap(12, 24);
            ImageAttributes ta = new ImageAttributes();
            float[][] mm2 = new float[][]
            { 
                 new float[]{-0.4f,-0.4f,- 0.4f, 0, 0},
                 new float[]{-0.3f,-0.3f,-0.3f, 0, 0},
                 new float[]{-0.3f, -0.3f, -0.3f, 0, 0},
                 new float[]{1,1, 1, 1, 0},
                 new float[]{0,0,0,0, 1}
            };
            Font printstring;
            if(fontindex>fontFamilies.Length-1)
            {
                fontindex=fontindex-(fontFamilies.Length-1);
                printstring=new Font(privatefontFamilies[fontindex-1].Name,8);
                
            }
            else
            {
                printstring = new Font(fontFamilies[fontindex],8);
            }

            


           
            



            ColorMatrix cmt = new ColorMatrix(mm2);
            ta.SetColorMatrix(cmt, ColorMatrixFlag.Default, ColorAdjustType.Bitmap);
            ColorMap map1 = new ColorMap();
            map1.OldColor = Color.Black;
            map1.NewColor = Color.White;
            ColorMap map2 = new ColorMap();
            map2.OldColor = Color.White;
            map2.NewColor = Color.Black;

            ta.SetRemapTable(new ColorMap[] { map1, map2 }, ColorAdjustType.Bitmap);
            Bitmap bmp = new Bitmap(img.Width, img.Height);
            Graphics g = Graphics.FromImage(bmp);

            //g.DrawString(character, new Font("新細明體", 8), new SolidBrush(Color.Black), 0, 0);
            g.DrawString(character, printstring, new SolidBrush(Color.Black), 0, 0);
            //g.DrawString(character, regFont, new SolidBrush(Color.Black), 0, 0);
            g.DrawImage(img, new Rectangle(0, 0, bmp.Width, bmp.Height), 0, 0, img.Width, img.Height, GraphicsUnit.Pixel, ta);
            g.Dispose();
            int midrgb = Color.FromArgb(0, 0, 0).ToArgb();
            int stride;
            stride = bmp.Height % 8 == 0 ? (bmp.Height / 8) : (bmp.Height / 8) + 1;
            int k = bmp.Width * stride;
            byte[] buf = new byte[k];
            for (int i = 0; i < bmp.Width; i++)
            {
                k = i * stride;
                int x = 0, ab = 0;
                for (int j = 0; j < bmp.Height; j++)
                {
                    if ((bmp.GetPixel(i, j)).ToArgb() > midrgb) ab = ab * 2 + 1; else ab = ab * 2;
                    x++;
                    if (x == 8)
                    {
                        buf[k++] = (byte)(255 - ab);
                        ab = 0;
                        x = 0;
                    }
                }
            }
            ArrayList to_move = new ArrayList();
            for(int i=0;i<buf.Length;i++)
            {
                to_move.Add(buf[i]);
            }
            to_move.Insert(0, Convert.ToByte(12));
            //to_move.ToArray(buf);

            return to_move;
        }

        public void Downloaded_Character_Set_SpecifyCancel(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x25, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x25, Convert.ToByte(x) }, 0, 3);
                }
            }


            
        }

        public void Downloaded_Character_Release(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x3F, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x3F, Convert.ToByte(x) }, 0, 3);
                }
            }


            
        }

        public void Downloaded_Character_All_Release(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x44, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x44, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Optional_Font_Select(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x4F, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x4F, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Optional_Font_Registration()
        {

            ////
            ////待解決
            ////
        }

        public void Optional_Font_Release()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x51 }, 0,2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x51 }, 0, 2);
                }
            }

            
        }


        /// <summary>
        /// Character Position
        /// </summary>
        /// 

        public void Page_Mode_Select()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x4C }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x4C }, 0, 2);
                }
            }

            
        }

        public void Standard_Mode_Select()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x53 }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x53 }, 0, 2);
                }
            }
            
        }

        public void Basic_Calculation_Pitch_Set(int x, int y)
        {

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x50, Convert.ToByte(x), Convert.ToByte(y) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x50, Convert.ToByte(x), Convert.ToByte(y) }, 0, 4);
                }
            }
            
        }

        public void Horizontal_Tab()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x09}, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x09 }, 0, 1);
                }
            }
            
        }

        public void Horizontal_Tab_Position_Set()
        {
            ////
            ////待解決
            ////
        }

        public void Alignment(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x61, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x61, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }

        public void Left_Margin_Set(int x)
        {
            int nl = x % 256;
            int nh = x / 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x4C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x4C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }
            
        }

        public void Print_Area_Width_Set(int x)
        {
            int nl = x % 256;
            int nh = x / 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x57, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x57, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }

            
        }

        public void Character_Print_Direction_Specify_in_Page_Mode(int x)

        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x54, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x54, Convert.ToByte(x) }, 0, 3);
                }
            }
            
        }

        public void Print_Area_Set_in_Page_Mode(int Horizontal_starting,int Vertical_starting,int Horizontal_length,int Vertical_length)
        {
            int xh = Horizontal_starting / 256;
            int xl = Horizontal_starting % 256;
            int yh = Vertical_starting / 256;
            int yl = Vertical_starting % 256;

            int dxh = Horizontal_length / 256;
            int dxl = Horizontal_length % 256;
            int dyh = Vertical_length / 256;
            int dyl = Vertical_length % 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x57, Convert.ToByte(xl), Convert.ToByte(xh), Convert.ToByte(yl), Convert.ToByte(yh), Convert.ToByte(dxl), Convert.ToByte(dxh), Convert.ToByte(dyl), Convert.ToByte(dyh) }, 0, 10, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x57, Convert.ToByte(xl), Convert.ToByte(xh), Convert.ToByte(yl), Convert.ToByte(yh), Convert.ToByte(dxl), Convert.ToByte(dxh), Convert.ToByte(dyl), Convert.ToByte(dyh) }, 0, 10);
                }
            }

           

        }

        public void Absolute_Position_Specify(int x)
        {
            int nl = x % 256;
            int nh = x / 256;
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x24, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x24, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }
            
        }

        public void Relative_Position_Specify(int x)
        {
            int nl = x % 256;
            int nh = x / 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x5C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x5C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }
           
        }

        public void Vertical_Absolute_Position_Specify_in_PageMode(int x)
        {
                        int nl = x % 256;
            int nh = x / 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] {  0x1D, 0x24, Convert.ToByte(nl), Convert.ToByte(nh)  }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x24, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }
            
        }
//
        public void Vertical_Relative_Position_Specify_in_Page_Mode(int x)
        {
            int nl = x % 256;
            int nh = x / 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x5C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x5C, Convert.ToByte(nl), Convert.ToByte(nh) }, 0, 4);
                }
            }
            
        }
        

        /// <summary>
        /// Image
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        /// <param name="z"></param>
        /// <param name="data"></param>
        public void Bit_Image_Mode_Print(int x,int lenhth,byte[] data)
        {
            int y = lenhth %  256;
            int z = lenhth /256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x2A, Convert.ToByte(x), Convert.ToByte(y), Convert.ToByte(z) }, 0,5, 1000, out bytesWritten);
                    write.Write(data, 0, data.Length, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x2A, Convert.ToByte(x), Convert.ToByte(y), Convert.ToByte(z) }, 0, 5);
                    serialPort1.Write(data, 0, data.Length);
                }
            }

            
            //Line_Feed();
        }
        private byte[] BmpToBytes_MemStream(Bitmap bmp)
        {
            BitmapData bmData = bmp.LockBits(new Rectangle(0, 0, bmp.Width, bmp.Height), ImageLockMode.ReadWrite, PixelFormat.Format1bppIndexed); 
            //BitmapData bmData = bmp;
            int x = bmData.Stride;
            int y = bmp.Width / 8;
            int shift = x - y;

            MemoryStream ms = new MemoryStream();
            bmp.Save(ms, System.Drawing.Imaging.ImageFormat.Bmp);
            byte[] bmpBytes = ms.ToArray();
            bmpBytes[0] = Convert.ToByte(bmp.Width/256);
            bmpBytes[2] = Convert.ToByte(bmp.Height/256);
            bmpBytes[1]=Convert.ToByte(bmp.Width%256);
            bmpBytes[3]=Convert.ToByte(bmp.Height%256);
            bmpBytes[4] = Convert.ToByte(shift);
            ms.Close();
            bmp.UnlockBits(bmData);
            return bmpBytes;
        }

        private void GrayScale(Bitmap b)
        {
            // GDI+ still lies to us - the return format is BGR, NOT RGB.
            BitmapData bmData = b.LockBits(new Rectangle(0, 0, b.Width, b.Height), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);

            int stride = bmData.Stride;
            System.IntPtr Scan0 = bmData.Scan0;

            unsafe
            {
                byte* p = (byte*)(void*)Scan0;

                int nOffset = stride - b.Width * 3;

                byte red, green, blue;

                for (int y = 0; y < b.Height; ++y)
                {
                    for (int x = 0; x < b.Width; ++x)
                    {
                        blue = p[0];
                        green = p[1];
                        red = p[2];

                        p[0] = p[1] = p[2] = (byte)(.299 * red + .587 * green + .114 * blue);

                        p += 3;
                    }
                    p += nOffset;
                }
            }

            b.UnlockBits(bmData);
        }


        private byte[] BmpToBytes_MemStream_new(Bitmap img)
        {
            //GrayScale(img);
            ImageAttributes ta = new ImageAttributes();
            //float[][] mm2 = new float[][]
            //{ 
            //     new float[]{-0.4f,-0.4f,- 0.4f, 0, 0},
            //     new float[]{-0.3f,-0.3f,-0.3f, 0, 0},
            //     new float[]{-0.3f, -0.3f, -0.3f, 0, 0},
            //     new float[]{1,1, 1, 1, 0},
            //     new float[]{0,0,0,0, 1}
            //};

            float[][] mm2 = new float[][]
            { 
                 new float[]{0.299f,0.299f,0.299f, 0, 0},
                 new float[]{0.587f,0.587f,0.587f, 0, 0},
                 new float[]{0.114f, 0.114f, 0.114f, 0, 0},
                 new float[]{0,0, 0, 1, 0},
                 new float[]{0,0,0,0, 0}
            };

            ColorMatrix cmt = new ColorMatrix(mm2);
            ta.SetColorMatrix(cmt, ColorMatrixFlag.Default, ColorAdjustType.Bitmap);
            ColorMap map1 = new ColorMap();
            map1.OldColor = Color.Black;
            map1.NewColor = Color.White;
            ColorMap map2 = new ColorMap();
            map2.OldColor = Color.White;
            map2.NewColor = Color.Black;

            ta.SetRemapTable(new ColorMap[] { map1, map2 }, ColorAdjustType.Bitmap);
            Bitmap bmp;
            if (img.Height % 8 != 0)
            {
                int heigh = (img.Height / 8) + 1;
                bmp = new Bitmap(img.Width, heigh*8);
            }
            else
            {
                bmp = new Bitmap(img.Width, img.Height);
            }
            Graphics g = Graphics.FromImage(bmp);

            //g.DrawString(character, new Font("新細明體", 8), new SolidBrush(Color.Black), 0, 0);
            //g.DrawString(character, printstring, new SolidBrush(Color.Black), 0, 0);
            //g.DrawString(character, regFont, new SolidBrush(Color.Black), 0, 0);
            g.DrawImage(img, new Rectangle(0, 0, bmp.Width, bmp.Height), 0, 0, img.Width, img.Height, GraphicsUnit.Pixel, ta);
            g.Dispose();
            int midrgb = Color.FromArgb(0, 0, 0).ToArgb();
            int stride;
            stride = bmp.Height % 8 == 0 ? (bmp.Height / 8) : (bmp.Height / 8) + 1;
            int k = bmp.Width * stride;
            byte[] buf = new byte[k];
            for (int i = 0; i < bmp.Width; i++)
            {
                k = i * stride;
                int x = 0, ab = 0;
                for (int j = 0; j < bmp.Height; j++)
                {
                    if ((bmp.GetPixel(i, j)).ToArgb() > midrgb) ab = ab * 2 + 1; else ab = ab * 2;
                    x++;
                    if (x == 8)
                    {
                        buf[k++] = (byte)ab;
                        ab = 0;
                        x = 0;
                    }
                }
            }
            byte[] to_move = new byte[buf.Length+5];
            for (int i = 0; i < buf.Length; i++)
            {
                to_move[i]=buf[i];
            }

            to_move[buf.Length + 0] = Convert.ToByte(bmp.Width / 256);
            to_move[buf.Length + 2] = Convert.ToByte((stride*8) / 256);
            to_move[buf.Length + 1] = Convert.ToByte(bmp.Width % 256);
            to_move[buf.Length + 3] = Convert.ToByte((stride * 8) % 256);
            to_move[buf.Length + 4] = Convert.ToByte(0);
            //to_move.Insert(0, Convert.ToByte(12));
            //to_move.ToArray(buf);

            return to_move;
        }
        private byte[] right_data(byte[] x)
        {

            for (int i = 5; i < x.Length; i++)
            {
                 x[i] = Convert.ToByte(255 - Convert.ToInt16(x[i]));
            }

            int image_wid=Convert.ToInt16(x[0])*256+(Convert.ToInt16(x[1]));
            int image_hei=(Convert.ToInt16(x[2])*256+Convert.ToInt16(x[3]) );

            byte[] test2 = new byte[image_wid * image_hei / 8+5];
            int go = 0;
            for (int i = 1; i < image_hei; i++)
            {
                if (i < image_hei)
                {
                    for (int o = 0; o < image_wid / 8; o++)
                    {
                        test2[go] = x[x.Length - (image_wid / 8 + Convert.ToInt16(x[4])) * i + o];
                        go++;
                    }
                }
            }
            test2[test2.Length - 5] = x[0];
            test2[test2.Length - 4] = x[1];

            test2[test2.Length - 3] = x[2];
            test2[test2.Length - 2] = x[3];
            test2[test2.Length - 1] = x[4];
            return test2;

        }

        public void Downloaded_Bit_Image_Registration(Bitmap x)
        {
            byte[] data = null;
            Bit_Image_Scan_Method_Selection(0);
            //data = right_data(BmpToBytes_MemStream(x));
            data = BmpToBytes_MemStream_new(x);
            //int image_wid = (Convert.ToInt16(data[data.Length - 5]) * 256 + Convert.ToInt16(data[data.Length - 4])) / 8;
            int image_wid = (Convert.ToInt16(data[data.Length - 5]) * 256 + Convert.ToInt16(data[data.Length - 4]))/8;
            int image_hei = (Convert.ToInt16(data[data.Length - 3]) * 256 + Convert.ToInt16(data[data.Length - 2])) / 8;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x2A, Convert.ToByte(image_wid), Convert.ToByte(image_hei) }, 0, 4, 1000, out bytesWritten);
                    int move = image_hei * image_wid*8 ;
                    write.Write(data, 0, move, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x2A, Convert.ToByte(image_wid), Convert.ToByte(image_hei) }, 0, 4);
                    int move = image_hei * image_wid * 8;

                    serialPort1.Write(data, 0, move);
                }
            }


            
        }

        public void Downloaded_Bit_Image_Print(int position)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x2F, Convert.ToByte(position) }, 0, 3, 1000, out bytesWritten);

                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x2F, Convert.ToByte(position) }, 0, 3);
                }
            }
        }

        public void Bit_Image_Print(int position, int left_length)
        {

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x2F, Convert.ToByte(position), Convert.ToByte(left_length) }, 0, 4, 1000, out bytesWritten);

                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x2F, Convert.ToByte(position), Convert.ToByte(left_length) }, 0, 4);

                }
            }
        }

        public void Raster_Bit_Image_Print()
        {
            ////
            ////待解決
            ////
        }


        public void NV_Bit_Image_Print(int index,int position)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1C, 0x70, Convert.ToByte(index), Convert.ToByte(position) }, 0, 4, 1000, out bytesWritten);

                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1C, 0x70, Convert.ToByte(index), Convert.ToByte(position) }, 0, 4);
            
                }
            }
            
        }


        public void NV_Bit_Image_Selection(int index, int position, int left_length)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1C, 0x70, Convert.ToByte(index), Convert.ToByte(position), Convert.ToByte(left_length) }, 0, 5, 1000, out bytesWritten);

                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1C, 0x70, Convert.ToByte(index), Convert.ToByte(position), Convert.ToByte(left_length) }, 0, 5);
            
                }
            }

        }

        public void NV_Bit_Image_Define(Bitmap x, int y)
        {
            //byte[] test = right_data(BmpToBytes_MemStream(x));
            byte[] test = BmpToBytes_MemStream_new(x);
            Bit_Image_Scan_Method_Selection(0);
            int wid = (Convert.ToInt16(test[test.Length - 5]) * 256 + Convert.ToInt16(test[test.Length - 4])) / 8;
            int hei = (Convert.ToInt16(test[test.Length - 3]) * 256 + Convert.ToInt16(test[test.Length - 2])) / 8;
            int xhi = wid / 256;
            int xli = wid % 256;

            int yhi = hei / 256;
            int yli = hei % 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1C, 0x71, Convert.ToByte(y), Convert.ToByte(xli), Convert.ToByte(xhi), Convert.ToByte(yli), Convert.ToByte(yhi) }, 0, 7, 1000, out bytesWritten);
                    int move = wid * hei * 8;
                    write.Write(test, 0, move,1000,out bytesWritten);
                    
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1C, 0x71, Convert.ToByte(y), Convert.ToByte(xli), Convert.ToByte(xhi), Convert.ToByte(yli), Convert.ToByte(yhi) }, 0, 7);
                    int move = wid * hei * 8;
                    serialPort1.Write(test, 0, move);
                }
            }


            
        }

        public void NV_Bit_Image_Define(Bitmap x, Bitmap z, int y)
        {
            //byte[] test = right_data(BmpToBytes_MemStream(x));
            byte[] test =BmpToBytes_MemStream_new(x);
            Bit_Image_Scan_Method_Selection(0);
            int wid = (Convert.ToInt16(test[test.Length -5]) * 256 + Convert.ToInt16(test[test.Length - 4])) / 8;
            int hei = (Convert.ToInt16(test[test.Length - 3]) * 256 + Convert.ToInt16(test[test.Length - 2])) / 8;
            int xhi = wid / 256;
            int xli = wid % 256;
            int yhi = hei / 256;
            int yli = hei % 256;

            //byte[] test1 = right_data(BmpToBytes_MemStream(z));
            byte[] test1 = BmpToBytes_MemStream_new(z);
            Bit_Image_Scan_Method_Selection(0);
            int wid1 = (Convert.ToInt16(test1[test1.Length - 5]) * 256 + Convert.ToInt16(test1[test1.Length - 4])) / 8;
            int hei1 = (Convert.ToInt16(test1[test1.Length - 3]) * 256 + Convert.ToInt16(test1[test1.Length - 2])) / 8;
            int xhi1 = wid1 / 256;
            int xli1 = wid1 % 256;
            int yhi1 = hei1 / 256;
            int yli1 = hei1 % 256;

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1C, 0x71, Convert.ToByte(y), Convert.ToByte(xli), Convert.ToByte(xhi), Convert.ToByte(yli), Convert.ToByte(yhi) }, 0, 7, 1000, out bytesWritten);
                    int move = wid * hei * 8;
                    write.Write(test, 0, move, 1000,out bytesWritten);

                    write.Write(new byte[] { Convert.ToByte(xli1), Convert.ToByte(xhi1), Convert.ToByte(yli1), Convert.ToByte(yhi1) }, 0, 4, 1000, out bytesWritten);
                    int move2 = wid1 * hei1 * 8;
                    write.Write(test1, 0, move2,1000,out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1C, 0x71, Convert.ToByte(y), Convert.ToByte(xli), Convert.ToByte(xhi), Convert.ToByte(yli), Convert.ToByte(yhi) }, 0, 7);
                    int move1 = wid * hei * 8;
                    serialPort1.Write(test, 0, move1);
                    serialPort1.Write(new byte[] { Convert.ToByte(xli1), Convert.ToByte(xhi1), Convert.ToByte(yli1), Convert.ToByte(yhi1) }, 0, 4);

                    int move2 = wid1 * hei1 * 8;

                    serialPort1.Write(test1, 0, move2);
                }
            }


           
            
            
            

        }

        public void Bit_Image_Scan_Method_Selection(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x49, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x49, Convert.ToByte(x) }, 0, 3);
                }
            }
        }

        public void Image_LSBMSB_Selection(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x3D, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x3D, Convert.ToByte(x) }, 0, 3);
                }
            }

            
        }



        /// <summary>
        /// 20091106 image 完成
        /// </summary>
        /// <param name="x"></param>

        


        public Bitmap KiResizeImage(Bitmap bmp, int newW, int newH)
        {
            try
            {
                Bitmap b = new Bitmap(newW, newH);
                Graphics g = Graphics.FromImage(b);
                g.InterpolationMode = InterpolationMode.HighQualityBicubic;

                g.DrawImage(bmp, new Rectangle(0, 0, newW, newH), new Rectangle(0, 0, bmp.Width, bmp.Height), GraphicsUnit.Pixel);
                g.Dispose();

                return b;
            }
            catch
            {
                return null;
            }
        }




        /// <summary>
        /// Auxiliary Function
        /// </summary>
        /// 
        public void Peripheral_Equipment_Selection(int Function)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x3D, Convert.ToByte(Function) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x3D, Convert.ToByte(Function) }, 0, 3);
                }
            }


            
        }
        public void Printer_Initialize()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x40 }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x40 }, 0, 2);
                }
            }

            
        }
        public void Hardware_Reset()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x40 }, 0, 2 ,2000, out bytesWritten);
                    device_reg_current = null;
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x40 }, 0, 2);
                    serialPort1.Close();
                }
            }

           
        }
        public void Marked_Paper_Form_Feed_Position_Correct(int Print_Position, int n)
        {
            //serialPort1.Write(new byte[] { 0x1D, 0x0C}, 0, 2);
            //serialPort1.Write(new byte[] { 0x1D, 0x3C}, 0, 2);
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    int test;
                    write.Write(new byte[] { 0x1D, 0x41, Convert.ToByte(Print_Position), Convert.ToByte(n) }, 0, 4, 1000, out test);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x41, Convert.ToByte(Print_Position), Convert.ToByte(n) }, 0, 4);
                }
            }
            serialPort1.Write(new byte[] { 0x1D, 0x41, Convert.ToByte(Print_Position), Convert.ToByte(n) }, 0, 4);
        }
        public void Remaining_Memory_Capacity_Response()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x2A, 0x32 }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x2A, 0x32 }, 0, 3);
                }
            }
        }
        public void Extension_Memory_Initialize()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x52, 0x01 }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x52, 0x01 }, 0, 3); 
                }
            }

            
        }
        public void Function_Settings(int switch_dip, byte[] data)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x77, Convert.ToByte(switch_dip) }, 0, 3, 1000, out bytesWritten);
                    write.Write(data, 0, data.Length, 1000, out bytesWritten);
                    write.Write(new byte[] { 0x00 }, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x77, Convert.ToByte(switch_dip) }, 0, 3);
                    serialPort1.Write(data, 0, data.Length);
                    serialPort1.Write(new byte[] { 0x00 }, 0, 1);
                }
            }

            
        }
        public void Function_Set_Response()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x6C, Convert.ToByte(0) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x6C, Convert.ToByte(0) }, 0, 3);
                }
            }

            
        }
        public void Execution_Response_Request(int finish)
        {

            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x71, Convert.ToByte(finish) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x71, Convert.ToByte(finish) }, 0, 3);
                }
            }
            
        }
        public void Test_Print()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x74 }, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x74 }, 0, 2);
                }
            }


            
        }
        public void Print_Stop_Capable_Paper_Sensor_Selection(int n)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1B, 0x63, 0x34, Convert.ToByte(n) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1B, 0x63, 0x34, Convert.ToByte(n) }, 0, 4);
                }
            }
           
        }
        int bytesWritten;
        public void Status_Data_Send(int n)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x72, Convert.ToByte(n) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x72, Convert.ToByte(n) }, 0, 3);
                }
            }
        }
        public void Automatic_Status_Back_EnableDisable(int n)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x61, Convert.ToByte(n) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x61, Convert.ToByte(n) }, 0, 3);
                }
            }
            
        }

        public void Paper_Cut_Position_Feed(int Function)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x56, Convert.ToByte(Function) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                   serialPort1.Write(new byte[] { 0x1D, 0x56, Convert.ToByte(Function) }, 0, 3);
                }
            }
        }
        public void Paper_Cut_Position_Feed(int Function1, int Function2)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x1D, 0x56, Convert.ToByte(Function1), Convert.ToByte(Function2) }, 0, 4, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x56, Convert.ToByte(Function1), Convert.ToByte(Function2) }, 0, 4);
                }
            }
        }

        public void Print_Density_Specify(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x12, 0x7E, Convert.ToByte(x)}, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x7E, Convert.ToByte(x) }, 0, 3);
                }
            }
  
        }

        public void Ruled_Line_Buffer_Clear()
        {
            if (usb_or_serial)
            {
                if (device_reg_current!=null)
                {
                    write.Write(new byte[] { 0x13, 0x43}, 0, 2, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x13, 0x43 }, 0, 2);
                }
            }
            
        }

        public void Write(string txt)
        {
            if(txt!=null)
            {
                if (usb_or_serial)
                {
                    if (device_reg_current != null)
                    {
                            byte[] x = null;
                            for (int i = 0; i <txt.Length; i++)
                            {
                                x[i] = Convert.ToByte(txt[i]);
                            }
                        write.Write(x, 0, x.Length, 1000, out bytesWritten);
                    }
                }
                else
                {
                    if (serialPort1.IsOpen)
                    {

                        serialPort1.Write(txt);
                    }
                }
            }
        }
        
        /// <summary>
        /// 20091110完成
        /// </summary>


        /// <summary>
        /// HRI_Character_Print_Position_Selection
        /// </summary>
        /// <param name="x"></param>0~3
        public void HRI_Character_Print_Position_Selection(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1D, 0x48, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x48, Convert.ToByte(x) }, 0, 3);
                }
            }
        }

        /// <summary>
        /// HRI_Character_Typeface_Selection
        /// </summary>
        /// <param name="x"></param>0~1
        public void HRI_Character_Typeface_Selection(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1D, 0x66, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x66, Convert.ToByte(x) }, 0, 3);
                }
            }
        }

        /// <summary>
        /// Barcode_Height_Set
        /// </summary>
        /// <param name="x"></param>1~255
        public void Barcode_Height_Set(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1D, 0x68, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x68, Convert.ToByte(x) }, 0, 3);
                }
            }

        }
        /// <summary>
        /// Barcode_Horizontal_Size_Set
        /// </summary>
        /// <param name="x"></param>2~6
        public void Barcode_Horizontal_Size_Set(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x1D, 0x77, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x1D, 0x77, Convert.ToByte(x) }, 0, 3);
                }
            }
        }

        /// <summary>
        ///  Barcode_NW_Ratio_Set
        /// </summary>
        /// <param name="x"></param>0~2
        public void Barcode_NW_Ratio_Set(int x)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    write.Write(new byte[] { 0x12, 0x3A, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {

                    serialPort1.Write(new byte[] { 0x12, 0x3A, Convert.ToByte(x) }, 0, 3);
                }
            }
        }


        /// <summary>
        /// Barcode_Print
        /// </summary>
        /// <param name="x"></param>Barcode_system
        /// <param name="bar_code"></param>Barcode to print
        public void Barcode_Print(int x, string bar_code)
        {
            if (usb_or_serial)
            {
                if (device_reg_current != null)
                {
                    byte[] y = new byte[bar_code.Length];
                    for (int i = 0; i < bar_code.Length; i++)
                    {
                        y[i] = Convert.ToByte(bar_code[i]);
                    }

                    write.Write(new byte[] { 0x1D, 0x6B, Convert.ToByte(x) }, 0, 3, 1000, out bytesWritten);
                    write.Write(y, 0, y.Length, 1000, out bytesWritten);
                    write.Write(new byte[] { 0x00 }, 0, 1, 1000, out bytesWritten);
                }
            }
            else
            {
                if (serialPort1.IsOpen)
                {
                    byte[] y = new byte[bar_code.Length];
                    for (int i = 0; i < bar_code.Length; i++)
                    {
                        y[i] = Convert.ToByte(bar_code[i]);
                    }

                    serialPort1.Write(new byte[] { 0x1D, 0x6B, Convert.ToByte(x) }, 0, 3);
                    serialPort1.Write(y, 0, y.Length);
                    serialPort1.Write(new byte[] { 0x00 }, 0, 1);
                }
            }
        }
    }
 
 
}
