﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using System.IO.Ports;
using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;
using LibUsbDotNet.Descriptors;

namespace printer_test
{
    /// <summary>
    /// 加入c# to VB
    /// </summary>
    public class set_X_and_Y
    {
        private int x = 0;
        private int y = 0;
        public set_X_and_Y(int x, int y)
        {
            this.x = x;
            this.y = y;

        }
        public int X
        {
            get { return x; }
            set { x = value; }
        }
        public int Y
        {
            get { return y; }
            set { y = value; }

        }

    }
    public class set_alignment
    {
        private int alignment = 0;

        public set_alignment(int x)
        {
            this.alignment = x;
        }
        public int Get_alignment()
        {
            return alignment;
        }
        public bool Align_left
        {
            get
            {
                if (alignment == 0)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 0;
                }
                else
                {
                    alignment = 1;
                }
            }
        }
        public bool Centered
        {
            get
            {
                if (alignment == 1)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 1;
                }
                else
                {
                    alignment = 0;
                }

            }

        }
        public bool Align_right
        {
            get
            {
                if (alignment == 2)
                    return true;
                else
                    return false;
            }
            set
            {
                if (value)
                {
                    alignment = 2;
                }
                else
                {
                    alignment = 0;
                }

            }

        }

    }
    public class string_status
    {

        bool font = true;
        public bool FontA
        {
            get
            {
                return font;
            }
            set
            {
                font = value;
            }
        }

        set_X_and_Y string_set = new set_X_and_Y(0, 0);
        public set_X_and_Y String_set
        {
            get
            {
                return string_set;
            }
            set
            {
                string_set = value;
            }
        }

        bool underline = false;
        public bool Underline
        {
            get
            {
                return underline;
            }
            set
            {
                underline = value;
            }
        }

        bool bold = false;
        public bool Bold
        {
            get
            {
                return bold;
            }
            set
            {
                bold = value;
            }
        }

        bool double_strike = false;
        public bool Double_strike
        {
            get
            {
                return double_strike;
            }
            set
            {

                double_strike = value;
            }
        }

        bool rotate = false;
        public bool Rotate
        {
            get
            {
                return rotate;
            }
            set
            {

                rotate = value;
            }
        }

        bool flip = false;
        public bool Flip
        {
            get
            {
                return flip;
            }
            set
            {

                flip = value;
            }
        }

        bool reverse = false;
        public bool Reverse
        {
            get
            {
                return reverse;
            }
            set
            {

                reverse = value;
            }
        }

        set_alignment alignment = new set_alignment(0);
        public set_alignment String_Alignment
        {
            get
            {
                return alignment;
            }
            set
            {
                alignment = value;
            }
        }

        int space = 0;
        public int Space
        {
            get
            {
                return space;
            }
            set
            {

                space = value;
            }
        }

        int density = 100;
        public int Density
        {
            get
            {
                return density;
            }
            set
            {
                if (value >= 60 && value <= 140)
                {
                    density = value;
                }
                else
                {
                    MessageBox.Show("The value should be setting between 60~140");
                }

            }
        }


    }
    ////////////
    ////////////  status狀態設定完成 20091208
    ////////////
    public class string_to_print
    {
        public static Class1 to_vb = new Class1();
        

        int bytes;
        public void serial_port_open(string port_name,int brg,System.IO.Ports.Handshake handshake)
        {
            Class1.Serialport.PortName = port_name;
            Class1.Serialport.BaudRate = brg;
            Class1.Serialport.Handshake = handshake;
            Class1.Serialport.Open();
            to_vb.Init_serialport();
            Class1.Usb_or_serial = false;
        }
        public void usb_port_open(UsbRegistry usb_port_registry)
        {
            Class1.Device_reg_current = usb_port_registry;
            Class1.Device_reg_current.Device.Open();
            to_vb.Init_local_usbport();
            Class1.Usb_or_serial = true;
        }




        public void print_status_set(string_status x)
        {
            if (x.FontA)
            {
                to_vb.Character_Font_Select(0);
            }
            else
            {
                to_vb.Character_Font_Select(1);
            }

            byte low;
            byte high;
            low = Convert.ToByte(x.String_set.X);
            high = Convert.ToByte(x.String_set.Y);
            to_vb.Character_Size_Specify((int)((high << 4) | low));

            if (x.Underline)
            {
                to_vb.Underline_Settings(2);
            }
            else
            {
                to_vb.Underline_Settings(0);
            }

            if (x.Bold)
            {
                to_vb.Bold_Print_SpecifyCancel(1);
            }
            else
            {
                to_vb.Bold_Print_SpecifyCancel(0);
            }

            if (x.Double_strike)
            {
                to_vb.Double_Strike_Printing_SpecifyCancel(1);
            }
            else
            {
                to_vb.Double_Strike_Printing_SpecifyCancel(0);
            }

            if (x.Rotate)
            {
                to_vb.Character_Right_Rotate_SpecifyCancel(1);
            }
            else
            {
                to_vb.Character_Right_Rotate_SpecifyCancel(0);
            }

            if (x.Flip)
            {
                to_vb.Inversion_Printing_SpecifyCancel(1);
            }
            else
            {
                to_vb.Inversion_Printing_SpecifyCancel(0);
            }

            if (x.Reverse)
            {
                to_vb.Reverse_Print_SpecifyCancel(1);
            }
            else
            {
                to_vb.Reverse_Print_SpecifyCancel(0);
            }

            switch (x.String_Alignment.Get_alignment())
            {
                case 0:
                    {
                        to_vb.Alignment(0);
                        break;
                    }
                case 1:
                    {
                        to_vb.Alignment(1);
                        break;
                    }
                case 2:
                    {
                        to_vb.Alignment(2);
                        break;
                    }
                default:
                    break;

            }

            to_vb.Character_Right_Space_Amount_Set(x.Space);
            to_vb.Print_Density_Specify(x.Density);

        }
        public void print_status_init()
        {
            string_status x = new string_status();
            print_status_set(x);
        }
        public void print(string string_print)
        {

            if (Class1.Usb_or_serial)
            {
                if (Class1.Device_reg_current != null)
                {
                    int bytes;
                    byte[] x = new byte[string_print.Length];
                    for (int i = 0; i < string_print.Length; i++)
                    {
                        x[i] = Convert.ToByte(string_print[i]);
                    }
                    Class1.write.Write(x, 0, x.Length, 1000, out bytes);
                    to_vb.Print_and_n_Lines_Feed_Forward(1);
                }
            }
            else
            {
                if (Class1.Serialport.IsOpen)
                {

                    Class1.Serialport.Write("" + string_print);
                    to_vb.Print_and_n_Lines_Feed_Forward(1);
                }
            }
            to_vb.Print_and_n_Lines_Feed_Forward(1);

        }
        public void print(string_status status, string string_print)
        {
            print_status_set(status);

            if (Class1.Usb_or_serial)
            {
                if (Class1.Device_reg_current != null)
                {
                    int bytes;
                    byte[] x = new byte[string_print.Length];
                    for (int i = 0; i < string_print.Length; i++)
                    {
                        x[i] = Convert.ToByte(string_print[i]);
                    }
                    Class1.write.Write(x, 0, x.Length, 1000, out bytes);
                }
            }
            else
            {
                if (Class1.Serialport.IsOpen)
                {

                    Class1.Serialport.Write("" + string_print);
                }
            }
            to_vb.Print_and_n_Lines_Feed_Forward(1);
        }  
        public void print_chinese(string chinese)
        {

            to_vb.Downloaded_Character_Registration(3, chinese);
            to_vb.Downloaded_Character_Set_SpecifyCancel(1);

            for (int i = 0; i < chinese.Length; i++)
            {

                if (Class1.Usb_or_serial)
                {
                    if (Class1.Device_reg_current != null)
                    {
                        Class1.write.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0,1, 1000, out bytes);
                    }
                }
                else
                {
                    if (Class1.Serialport.IsOpen)
                    {
                        Class1.Serialport.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1);
                    }
                }



               
            }
            to_vb.Downloaded_Character_Set_SpecifyCancel(0);
            to_vb.Print_and_n_Lines_Feed_Forward(1);
        }
        public void print_chinese(string_status s, string chinese)
        {
            print_status_set(s);
            to_vb.Downloaded_Character_Registration(3, chinese);
            to_vb.Downloaded_Character_Set_SpecifyCancel(1);

            for (int i = 0; i < chinese.Length; i++)
            {
                if (Class1.Usb_or_serial)
                {
                    if (Class1.Device_reg_current != null)
                    {
                        Class1.write.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0,1, 1000, out bytes);
                    }
                }
                else
                {
                    if (Class1.Serialport.IsOpen)
                    {
                        Class1.Serialport.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1);
                    }
                }
            }
            to_vb.Downloaded_Character_Set_SpecifyCancel(0);
            to_vb.Print_and_n_Lines_Feed_Forward(1);
        }
        public void Downloaded_Bit_Image_Registration(Bitmap x)
        {
            to_vb.Downloaded_Bit_Image_Registration(x);
        }
        public void NV_Bit_Image_Define(Bitmap x)
        {
            to_vb.NV_Bit_Image_Define(x, 1);
        }
        public void NV_Bit_Image_Define(Bitmap x, Bitmap y)
        {
            to_vb.NV_Bit_Image_Define(x, y,2);
        }
        public void Downloaded_Bit_Image_Print(int x)
        {
            to_vb.Downloaded_Bit_Image_Print(x);
        }
        public void Bit_Image_Print(int x,int y)
        {
            to_vb.Bit_Image_Print(x, y);
        }
        public void NV_Bit_Image_Print(int x,int y)
        {
            to_vb.NV_Bit_Image_Print(x, y);
        }
        public void NV_Bit_Image_Selection(int x,int y,int z)
        {
            to_vb.NV_Bit_Image_Selection(x, y, z);
        }

        public void Paper_Cut_Position_Feed(int x)
        {
            to_vb.Paper_Cut_Position_Feed(x);
        }
        /// <summary>
        /// 以 n*basic calculation pitch設定 forward 
        /// </summary>
        /// <param name="x"></param> 前進 x*n*basic calculation pitch(34dot)
        public void Print_and_Feed_Forward(int x)
        {
            to_vb.Print_and_Feed_Forward(x);
        }
        /// <summary>
        /// 以 n*the specified line spacing*basic calculation pitch設定 forward 
        /// </summary>
        /// <param name="x"></param>前進 x*n*the specified line spacing*basic calculation pitch(34dot)
        public void Print_and_n_Lines_Feed_Forward(int x)
        {
            to_vb.Print_and_n_Lines_Feed_Forward(x);
        }
        /// <summary>
        /// default 1/6 inch = 34dot 
        /// </summary>
        /// <param name="x"></param>203
        /// <param name="y"></param>203
        public void Basic_Calculation_Pitch_Set(int x,int y)
        {
            to_vb.Basic_Calculation_Pitch_Set(x, y);
        }
    }
}
