﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Drawing.Imaging;
using System.IO;
using System.Threading;
using System.Collections;
using System.Drawing.Text;
using System.Drawing.Drawing2D;

using LibUsbDotNet;
using LibUsbDotNet.LibUsb;
using LibUsbDotNet.Main;


namespace printer_test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            Form.CheckForIllegalCrossThreadCalls = false;
            ////////////////////////////////////////
            character_visible.underline.Add(0);
            character_visible.underline.Add(false);
            character_visible.align.Add(0);
            character_visible.align.Add(false);
            ///////////////////////////////////////
            disableToolStripMenuItem.Enabled = false;
            enableToolStripMenuItem.Enabled = true;
            //////////////////////////////////////

            //Class1.Device_reg_current = UsbGlobals.AllDevices[0];
           
        }


        printer_test.Class1 printer_fun = new printer_test.Class1();
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            if (MessageBox.Show("Are you sure you want to leave?", "Sure?", MessageBoxButtons.YesNo, MessageBoxIcon.Stop) == DialogResult.Yes)
            {
                Class2.Show_status.notifyIcon1.Visible = false;
                Class2.Show_status.Close();
                //Application.Exit();
                this.Close();
            }
        }

        private void rs232ComPortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 Rs232form = new Form2();

            if (Class1.Serialport.IsOpen == true)
            {
                if (MessageBox.Show("Already Open. ", " Want To Stop?", MessageBoxButtons.YesNo, MessageBoxIcon.Stop) == DialogResult.Yes)
                {

                    Class1.Serialport.Close();

                }
            }
            else
            {
                if (Rs232form.ShowDialog(this) == DialogResult.OK)
                {
                    printer_fun.Init_serialport();
                    Class1.Serialport.Open();
                    Class1.Usb_or_serial = false;
                }
            }

        }

        private void downloadedBitImageRegistrationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                OpenFileDialog openFileDialog1 = new OpenFileDialog();
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        string k = openFileDialog1.FileName;
                        picimg3 = (Bitmap)Bitmap.FromFile(k);

                        MemoryStream ms = new MemoryStream();
                        picimg3.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
                        System.Drawing.Bitmap x = new Bitmap(picimg3, pictureBox1.Width, pictureBox1.Height);


                        pictureBox1.Image = x;

                        printer_fun.Downloaded_Bit_Image_Registration(picimg3);

                    }
                    catch (ApplicationException ex)
                    {
                        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
            }
        }

        int picture_index=0;
        Bitmap picimg1 = null;
        Bitmap picimg2 = null;
        Bitmap picimg3 = null;

        private void nVBitImageDefineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                OpenFileDialog openFileDialog1 = new OpenFileDialog();
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    try
                    {

                        switch (picture_index)
                        {
                            case 0:
                                {
                                    string k = openFileDialog1.FileName;
                                    picimg1 = (Bitmap)Bitmap.FromFile(k);

                                    MemoryStream ms = new MemoryStream();
                                    picimg1.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
                                    System.Drawing.Bitmap x = new Bitmap(picimg1, pictureBox2.Width, pictureBox2.Height);

                                    printer_fun.NV_Bit_Image_Define(picimg1, 1);
                                    pictureBox2.Image = x;
                                    picture_index = 1;
                                    break;


                                }
                            case 1:
                                {
                                    string k = openFileDialog1.FileName;
                                    picimg2 = (Bitmap)Bitmap.FromFile(k);

                                    MemoryStream ms6 = new MemoryStream();
                                    picimg2.Save(ms6, System.Drawing.Imaging.ImageFormat.Png);
                                    System.Drawing.Bitmap x = new Bitmap(picimg2, pictureBox3.Width, pictureBox3.Height);

                                    printer_fun.NV_Bit_Image_Define(picimg1, picimg2, 2);
                                    pictureBox3.Image = x;
                                    picture_index = 2;
                                    break;
                                }
                            default:
                                {

                                    picimg1 = picimg2;
                                    string k = openFileDialog1.FileName;
                                    picimg2 = (Bitmap)Bitmap.FromFile(k);

                                    MemoryStream ms1 = new MemoryStream();
                                    picimg1.Save(ms1, System.Drawing.Imaging.ImageFormat.Png);
                                    System.Drawing.Bitmap x1 = new Bitmap(picimg1, pictureBox2.Width, pictureBox2.Height);
                                    MemoryStream ms2 = new MemoryStream();
                                    picimg2.Save(ms2, System.Drawing.Imaging.ImageFormat.Png);
                                    System.Drawing.Bitmap x2 = new Bitmap(picimg2, pictureBox3.Width, pictureBox3.Height);

                                    printer_fun.NV_Bit_Image_Define(picimg1, picimg2, 2);
                                    pictureBox2.Image = x1;
                                    pictureBox3.Image = x2;
                                    break;
                                }
                        }

                    }
                    catch (ApplicationException ex)
                    {
                        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }



                }
            }
        }

        private void normalModePrintingToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
                if (pictureBox1.Image != null)
                {
                    printer_fun.Downloaded_Bit_Image_Print(0);
                }


        }

        private void doubleWidthModePrintingToolStripMenuItem_Click(object sender, EventArgs e)
        {

                if (pictureBox1.Image != null)
                {
                    printer_fun.Downloaded_Bit_Image_Print(1);
                }
        }

        private void doubleHeightModePrintingToolStripMenuItem_Click(object sender, EventArgs e)
        {
                if (pictureBox1.Image != null)
                {
                    printer_fun.Downloaded_Bit_Image_Print(2);
                }
        }

        private void doubleHeightAndWidthModePrintingToolStripMenuItem_Click(object sender, EventArgs e)
        {

            if (pictureBox1.Image != null)
            {
                printer_fun.Downloaded_Bit_Image_Print(3);
            }

        }

        private void normalModePrintingToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //if (pictureBox2.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(1, 0);
                //}

        }

        private void doubleWidthModePrintingToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //if (pictureBox2.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(1, 1);
                //}
        }

        private void doubleHeightModePrintingToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //if (pictureBox2.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(1, 2);
                //}

        }

        private void doubleHeightAndWidthPrintingToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //if (pictureBox2.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(1, 3);
                //}

        }


        private void normalModePrintingToolStripMenuItem2_Click(object sender, EventArgs e)
        {

                //if (pictureBox3.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(2, 0);
                //}
        }

        private void doubleWidthModePrintingToolStripMenuItem2_Click(object sender, EventArgs e)
        {

                //if (pictureBox3.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(2, 1);
                //}
        }

        private void doubleHeightModePrintingToolStripMenuItem2_Click(object sender, EventArgs e)
        {

                //if (pictureBox3.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(2, 2);
                //}
        }

        private void doubleHeightAndWidthPrintingToolStripMenuItem1_Click(object sender, EventArgs e)
        {
                //if (pictureBox3.Image != null)
                //{
                    printer_fun.NV_Bit_Image_Print(2, 3);
                //}
        }

        private void printerInitialToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                printer_fun.Printer_Initialize();
                all_disable();
                Form10 wait = new Form10();
                wait.timer1.Enabled = true;
                if (wait.ShowDialog(this) == DialogResult.OK)
                {
                    wait.Close();
                }
            }
 
        }
        private void all_disable()
        {
            selectFontAToolStripMenuItem.Checked = false;
            selectFontBToolStripMenuItem.Checked = false;
            character_visible.fontA = false;
            character_visible.fontB = false;

            for (int i = 0; i < 8; i++)
            {
                ((ToolStripMenuItem)horizontalScaleToolStripMenuItem.DropDownItems[i]).Checked = false;
                    ((ToolStripMenuItem)verticalScaleToolStripMenuItem.DropDownItems[i]).Checked = false;
            }
            character_visible.font_h = 0;
            character_visible.font_v = 0;

            for (int i = 0; i < 3; i++)
            {
                ((ToolStripMenuItem)underlineSettingsToolStripMenuItem.DropDownItems[i]).Checked = false;
            }
            character_visible.underline[0]=0;
            character_visible.underline[1]=false;

            specifiesToolStripMenuItem.Checked = false;
            character_visible.bold = false;

            specifiesToolStripMenuItem1.Checked = false;
            character_visible.doublestrike = false;

            specifiesToolStripMenuItem2.Checked = false;
            character_visible.rotate = false;

            specifiesToolStripMenuItem3.Checked = false;
            character_visible.inverse = false;

            specifiesToolStripMenuItem4.Checked = false;
            character_visible.reverse = false;



            for (int i = 0; i < 3; i++)
            {
                ((ToolStripMenuItem)alignmentToolStripMenuItem.DropDownItems[i]).Checked = false;
            }

            character_visible.align[0]=0;
            character_visible.align[1]=false;

        }

        private void fullCutToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Paper_Cut_Position_Feed(0);
        }

        private void partialCutToolStripMenuItem_Click(object sender, EventArgs e)
        {


                printer_fun.Paper_Cut_Position_Feed(1);

        }

        private void cutPositionFeedForwardAndFullCutToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Paper_Cut_Position_Feed(0, 255);

        }

        private void feedForwardAndPartialCutToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Paper_Cut_Position_Feed(1, 255);

        }

        private void printDensitySpecifyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                Form3 Density = new Form3();
                if (Density.ShowDialog(this) == DialogResult.OK)
                {
                    printer_fun.Print_Density_Specify(Class3.Density);
                }
            }
        }

        private void selectFontAToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true||Class1.Device_reg_current!=null)
            {
                if (character_visible.fontA)
                {
                    character_visible.fontA = false;
                }
                turn_font(1, !character_visible.fontA);
                //printer_fun.Character_Font_Select(0);
            }
        }
        private void selectFontBToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                if (character_visible.fontB)
                {
                    character_visible.fontB = false;
                }
                turn_font(2, !character_visible.fontB);
                //printer_fun.Character_Font_Select(1);
            }
        }
        private void turn_font(int x,bool y)
        {
            switch(x)
            {
                case 1:
                    {
                        character_visible.fontA = y;
                        character_visible.fontB = !y;
                        selectFontAToolStripMenuItem.Checked = y;
                        selectFontBToolStripMenuItem.Checked = !y;
                        printer_fun.Character_Font_Select(0);
                        break;
                    }

                case 2:
                    {
                        character_visible.fontA = !y;
                        character_visible.fontB = y;
                        selectFontAToolStripMenuItem.Checked = !y;
                        selectFontBToolStripMenuItem.Checked = y;
                        printer_fun.Character_Font_Select(1);
                        break;
                    }
                default:
                    break;

            }

        }


        //int character_v = 0;
        //int character_h = 0;
        private void x1ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Character_Size_Specify(turn_size(0, character_visible.font_h));
        }

        private void x2ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 1;
                printer_fun.Character_Size_Specify(turn_size(1,character_visible.font_h));
        }

        private void x3ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 2;
                printer_fun.Character_Size_Specify(turn_size(2, character_visible.font_h));
        }

        private void x4ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 3;
                printer_fun.Character_Size_Specify(turn_size(3, character_visible.font_h));

        }

        private void x5ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 4;
                printer_fun.Character_Size_Specify(turn_size(4, character_visible.font_h));

        }


        private void x6ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 5;
                printer_fun.Character_Size_Specify(turn_size(5, character_visible.font_h));
        }

        private void x7ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 6;
                printer_fun.Character_Size_Specify(turn_size(6, character_visible.font_h));
        }

        private void x8ToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_v = 7;
                printer_fun.Character_Size_Specify(turn_size(7,character_visible.font_h));
        }
        private int turn_size(int v,int h)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                character_visible.font_v = v;
                character_visible.font_h = h;

                byte low;
                byte high;
                low = Convert.ToByte(v);
                high = Convert.ToByte(h);
                for (int i = 0; i < 8; i++)
                {
                    if (i == v)
                    {
                        ((ToolStripMenuItem)verticalScaleToolStripMenuItem.DropDownItems[i]).Checked = true;
                    }
                    else
                    {
                        ((ToolStripMenuItem)verticalScaleToolStripMenuItem.DropDownItems[i]).Checked = false;
                    }
                }
                for (int i = 0; i < 8; i++)
                {
                    if (i == h)
                    {
                        ((ToolStripMenuItem)horizontalScaleToolStripMenuItem.DropDownItems[i]).Checked = true;
                    }
                    else
                    {
                        ((ToolStripMenuItem)horizontalScaleToolStripMenuItem.DropDownItems[i]).Checked = false;
                    }
                }


                return (int)((high << 4) | low);
            }
            return 0;
            
        }



        private void x1defaultToolStripMenuItem_Click(object sender, EventArgs e)
        {

                //character_h = 0;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,0));

        }


        private void x2ToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //character_h = 16;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,1));
        }

        private void x3ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
                //character_h = 21;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,2));
        }


        private void x4ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
                //character_h = 48;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,3));

        }

        private void x5ToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //character_h = 64;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,4));

        }

        private void x6ToolStripMenuItem1_Click(object sender, EventArgs e)
        {

               // character_h = 80;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,5));
        }

        private void x7ToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //character_h = 96;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,6));

        }

        private void x8ToolStripMenuItem1_Click(object sender, EventArgs e)
        {

                //character_h = 112;
                printer_fun.Character_Size_Specify(turn_size(character_visible.font_v,7));

        }

        private void underlineSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void cancelUnderlineToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Underline_Settings(0);
        }

        private void set1dotHeightUnderlineAndSpecifyUnderlineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Underline_Settings(1);
                if ((int)character_visible.underline[0] == 2)
                {
                    character_visible.underline[1] = false;
                }
                turn_underline(1, !(bool)character_visible.underline[1]);
            }
        }

        private void set2dotHeightUnderlineAndSpecifyUnderlineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Underline_Settings(2);
                if ((int)character_visible.underline[0] == 1)
                {
                   character_visible.underline[1] = false;
                }
                turn_underline(2,!(bool)character_visible.underline[1]);
            }
        }

        private void turn_underline(int x,bool y)
        {

            if ((int)character_visible.underline[0] == x)
            {
                character_visible.underline[1]=y;
                if ((int)character_visible.underline[0]==1)
                {
                    ((ToolStripMenuItem)underlineSettingsToolStripMenuItem.DropDownItems[1]).Checked = y;
                    if (y)
                    {
                        printer_fun.Underline_Settings(1);
                    }
                    else
                    {
                        printer_fun.Underline_Settings(0);
                    }
                }
                else
                {
                    ((ToolStripMenuItem)underlineSettingsToolStripMenuItem.DropDownItems[2]).Checked = y;
                    if (y)
                    {
                        printer_fun.Underline_Settings(2);
                    }
                    else
                    {
                        printer_fun.Underline_Settings(0);
                    }
                }

            }
            else
            {
                    character_visible.underline[0] = x;
                    character_visible.underline[1] = y;
                    for (int i = 0; i < underlineSettingsToolStripMenuItem.DropDownItems.Count; i++)
                    {
                        ((ToolStripMenuItem)underlineSettingsToolStripMenuItem.DropDownItems[i]).Checked = false;
                    }
                    ((ToolStripMenuItem)underlineSettingsToolStripMenuItem.DropDownItems[x]).Checked = y;
                    printer_fun.Underline_Settings((int)character_visible.underline[0]);
            }

        }



        private void cancelsToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Bold_Print_SpecifyCancel(0);
        }

        private void specifiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Bold_Print_SpecifyCancel(1);
                turn_bold(!character_visible.bold);
            }
        }
        private void turn_bold(bool x)
        {
            character_visible.bold = x;
            specifiesToolStripMenuItem.Checked = x;
            if (x)
            {
                printer_fun.Bold_Print_SpecifyCancel(1);
            }
            else
            {
                printer_fun.Bold_Print_SpecifyCancel(0);
            }
        }

        private void cancelsToolStripMenuItem1_Click(object sender, EventArgs e)
        {
                printer_fun.Double_Strike_Printing_SpecifyCancel(0);
        }

        private void specifiesToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Double_Strike_Printing_SpecifyCancel(1);
                turn_doublestrike(!character_visible.doublestrike);
            }
        }
        private void turn_doublestrike(bool x)
        {
            character_visible.doublestrike= x;
            specifiesToolStripMenuItem1.Checked = x;
            if (x)
            {
                printer_fun.Double_Strike_Printing_SpecifyCancel(1);
            }
            else
            {
                printer_fun.Double_Strike_Printing_SpecifyCancel(0);
            }
        }



        private void cancelsToolStripMenuItem2_Click(object sender, EventArgs e)
        {

                printer_fun.Character_Right_Rotate_SpecifyCancel(0);
        }

        private void specifiesToolStripMenuItem2_Click(object sender, EventArgs e)
        {

                //printer_fun.Character_Right_Rotate_SpecifyCancel(1);
                turn_rotate(!character_visible.rotate);
        }
        private void turn_rotate(bool x)
        {
            character_visible.rotate = x;
            specifiesToolStripMenuItem2.Checked = x;
            if (x)
            {
                printer_fun.Character_Right_Rotate_SpecifyCancel(1);
            }
            else
            {
                printer_fun.Character_Right_Rotate_SpecifyCancel(0);
            }
        }


        private void cancelsToolStripMenuItem3_Click(object sender, EventArgs e)
        {

                printer_fun.Inversion_Printing_SpecifyCancel(0);
        }

        private void specifiesToolStripMenuItem3_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Inversion_Printing_SpecifyCancel(1);
                turn_inverse(!character_visible.inverse);
            }
        }
        private void turn_inverse(bool x)
        {
            character_visible.inverse = x;
            specifiesToolStripMenuItem3.Checked = x;
            if (x)
            {
                printer_fun.Inversion_Printing_SpecifyCancel(1);
            }
            else
            {
                printer_fun.Inversion_Printing_SpecifyCancel(0);
            }
        }






        private void cancelsToolStripMenuItem4_Click(object sender, EventArgs e)
        {

                printer_fun.Reverse_Print_SpecifyCancel(0);
        }

        private void specifiesToolStripMenuItem4_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!=null)
            {
                //printer_fun.Reverse_Print_SpecifyCancel(1);
                turn_reverse(!character_visible.reverse);
            }
        }
        private void turn_reverse(bool x)
        {
            character_visible.reverse = x;
            specifiesToolStripMenuItem4.Checked = x;
            if (x)
            {
                printer_fun.Reverse_Print_SpecifyCancel(1);
            }
            else
            {
                printer_fun.Reverse_Print_SpecifyCancel(0);
            }
        }




        private void alignLeftToolStripMenuItem_Click(object sender, EventArgs e)
        {

                printer_fun.Alignment(0);
        }

        private void centeredToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current.Device!=null)
            {
                if ((int)character_visible.align[0] == 2)
                {
                    character_visible.align[1] = false;
                }
                turn_align(1,!(bool)character_visible.align[1]);
                //printer_fun.Alignment(1);
            }
        }

        private void alignRightToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                if ((int)character_visible.align[0] == 1)
                {
                    character_visible.align[1] = false;
                }
                turn_align(2, !(bool)character_visible.align[1]);
                //printer_fun.Alignment(2);
            }
        }
        private void turn_align(int x,bool y)
        {
            if ((int)character_visible.align[0] == x)
            {
                character_visible.align[1] = y;
                if ((int)character_visible.align[0] == 1)
                {
                    ((ToolStripMenuItem)alignmentToolStripMenuItem.DropDownItems[1]).Checked = y;
                    if (y)
                    {
                        printer_fun.Alignment(1);
                    }
                    else
                    {
                        printer_fun.Alignment(0);
                    }
                }
                else
                {
                    ((ToolStripMenuItem)alignmentToolStripMenuItem.DropDownItems[2]).Checked = y;
                    if (y)
                    {
                        printer_fun.Alignment(2);
                    }
                    else
                    {
                        printer_fun.Alignment(0) ;
                    }
                }

            }
            else
            {
                character_visible.align[0] = x;
                character_visible.align[1] = y;
                for (int i = 0; i < underlineSettingsToolStripMenuItem.DropDownItems.Count; i++)
                {
                    ((ToolStripMenuItem)alignmentToolStripMenuItem.DropDownItems[i]).Checked = false;
                }
                ((ToolStripMenuItem)alignmentToolStripMenuItem.DropDownItems[x]).Checked = y;
                printer_fun.Alignment((int)character_visible.align[0]);
            }
        }





        private void printToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (richTextBox1.Text != "")
            {
                if (Class1.Usb_or_serial)
                {
                    if (Class1.Device_reg_current!= null)
                    {
                        int bytes;
                        byte[] x=new byte[richTextBox1.Text.Length];
                        for (int i = 0; i < richTextBox1.Text.Length; i++)
                        {
                            x[i] = Convert.ToByte(richTextBox1.Text[i]);
                        }
                        Class1.write.Write(x, 0, x.Length, 1000, out bytes);
                        printer_fun.Print_and_n_Lines_Feed_Forward(1);
                    }
                }
                else
                {
                    if (Class1.Serialport.IsOpen)
                    {

                        Class1.Serialport.Write("" + richTextBox1.Text);
                        printer_fun.Print_and_n_Lines_Feed_Forward(1);
                    }
                }
                
                
                //printer_fun.Line_Feed();
                //printer_fun.Marked_Paper_Print_and_Form_Feed();

            }

        }

        private void extensionMemoryInitializeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                printer_fun.Extension_Memory_Initialize();
                Form9 wait = new Form9();
                wait.timer1.Enabled = true;
                if (wait.ShowDialog(this) == DialogResult.OK)
                {
                    wait.Close();
                }
            }

        }

        private void hardwareResetToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                printer_fun.Hardware_Reset();
                Form12 hardware = new Form12();
                //hardware.timer1.Start();
                if (hardware.ShowDialog(this) == DialogResult.OK)
                {
                    hardware.Close();
                }
            }
        }

        private void functionSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                byte[] sw1 = new byte[1] { 0xE6 };
                byte[] sw2 = new byte[1] { 0xFF };
                byte[] sw3 = new byte[1] { 0xC1 };
                byte[] sw4 = new byte[1] { 0x64 };
                byte[] sw5 = new byte[1] { 0xF6 };
                byte[] sw6 = new byte[1] { 0x00 };
                byte[] sw7 = new byte[1] { 0x00 };
                byte[] sw8 = new byte[1] { 0x00 };
                byte[] sw9 = new byte[1] { 0x00 };
                byte[] sw10 = new byte[1] { 0x01 };
                byte[] sw11 = new byte[1] { 0xF4 };

                //printer_fun.Function_Settings(1 + 128, sw1);
                ////Thread.Sleep(500);
                //printer_fun.Function_Settings(2 + 128, sw2);
                ////Thread.Sleep(500);
                //printer_fun.Function_Settings(3 + 128, sw3);
                ////Thread.Sleep(500);
                //printer_fun.Function_Settings(4 + 128, sw4);
                ////Thread.Sleep(500);
                //printer_fun.Function_Settings(5 + 128, sw5);
                ////Thread.Sleep(500);
                Form13 function = new Form13();
                function.timer1.Start();
                if (function.ShowDialog(this) == DialogResult.OK)
                {
                    function.Close();
                }

            }
        }

        private void testPrintToolStripMenuItem_Click(object sender, EventArgs e)
        {
 
                printer_fun.Test_Print();
        }


        string paperSensorStatus_string = "";
        private void paperSensorStatusToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Class3.Window_execute = 1;
            printer_fun.evt_receivechar += new Class1.string_hander(printer_fun_evt_receivechar_paperSensor);
            printer_fun.Status_Data_Send(1);
        }
        
        void printer_fun_evt_receivechar_paperSensor(object s, stringeventargs e)
        {
            //if (Class1.Serialport.IsOpen == true)
            //{
            paperSensorStatus_string += e.Get_string;
            if (paperSensorStatus_string.ToCharArray().Length == 1)
            {
                printer_fun.evt_receivechar -= new Class1.string_hander(printer_fun_evt_receivechar_paperSensor);

                byte[] string_to_char = System.Text.Encoding.Unicode.GetBytes(paperSensorStatus_string.ToCharArray());
                //MessageBox.Show(Convert.ToInt16(string_to_char[0]).ToString());
                Form4 status = new Form4(Class3.Window_execute, string_to_char[0]);
                if (status.ShowDialog(this) == DialogResult.OK)
                {
                    status.Close();
                }
                paperSensorStatus_string = "";
            }
            //}
          
        }

        string presenterStatus_string="";
        private void presenterStatusToolStripMenuItem_Click(object sender, EventArgs e)
        {
                Class3.Window_execute = 2;
                printer_fun.evt_receivechar += new Class1.string_hander(printer_fun_evt_receivechar_presenter);
                printer_fun.Status_Data_Send(3);
        }
        void printer_fun_evt_receivechar_presenter(object s, stringeventargs e)
        {
                presenterStatus_string += e.Get_string;
                if (presenterStatus_string.ToCharArray().Length == 1)
                {
                    printer_fun.evt_receivechar -= new Class1.string_hander(printer_fun_evt_receivechar_presenter);
                    //MessageBox.Show(presenterStatus_string.ToCharArray().Length.ToString());
                    byte[] string_to_char = System.Text.Encoding.Unicode.GetBytes(presenterStatus_string.ToCharArray());
                    Form4 status = new Form4(Class3.Window_execute, string_to_char[0]);
                    if (status.ShowDialog(this) == DialogResult.OK)
                    {
                        status.Close();
                    }
                    presenterStatus_string = "";
                }
        }

        string remainingMemoryCapacityResponse_string="";
        private void remainingMemoryCapacityResponseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                Class3.Window_execute = 3;
                printer_fun.evt_receivechar += new Class1.string_hander(printer_fun_evt_receivechar_remainingMemoryCapacityResponse);
                printer_fun.Remaining_Memory_Capacity_Response();

            }
        }
        void printer_fun_evt_receivechar_remainingMemoryCapacityResponse(object s, stringeventargs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                remainingMemoryCapacityResponse_string += e.Get_string;
                if (remainingMemoryCapacityResponse_string.ToCharArray().Length == 12)
                {
                    printer_fun.evt_receivechar -= new Class1.string_hander(printer_fun_evt_receivechar_remainingMemoryCapacityResponse);
                    char[] good = remainingMemoryCapacityResponse_string.ToCharArray();
                    string remainingMemory = "";
                    for (int i = 0; i < remainingMemoryCapacityResponse_string.Length; i += 2)
                    {
                        remainingMemory += Convert.ToString(remainingMemoryCapacityResponse_string[i], 10);
                    }
                    Form4 status = new Form4(Class3.Window_execute, remainingMemory);
                    
                    if (status.ShowDialog(this)== DialogResult.OK)
                    {
                            status.Close();
                    }

                    //MessageBox.Show("RemainingMemoryCapacityResponse : " + Convert.ToInt16(remainingMemory).ToString() + " byte");
                    remainingMemoryCapacityResponse_string = "";
                }
            }
        }
 
        string functionSetResponse_string = "";
        private void functionSetResponseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                printer_fun.evt_receivechar += new Class1.string_hander(printer_fun_evt_receivechar_functionSetResponse);
                printer_fun.Function_Set_Response();
            }
        }
        void printer_fun_evt_receivechar_functionSetResponse(object s, stringeventargs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                functionSetResponse_string += e.Get_string;
                if (functionSetResponse_string.ToCharArray().Length == 80)
                {
                    printer_fun.evt_receivechar -= new Class1.string_hander(printer_fun_evt_receivechar_functionSetResponse);
                    char[] fun = functionSetResponse_string.ToCharArray();
                    MessageBox.Show(functionSetResponse_string.ToCharArray().Length.ToString());
                    functionSetResponse_string = "";
                }
            }
        }

        private void testPrintIiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int bytes;
                for (int i = 0; i < 256; i++)
                {
                    if (Class1.Usb_or_serial)
                    {
                        if (Class1.Device_reg_current!= null)
                        {
                            Class1.write.Write(new byte[] { Convert.ToByte(i) }, 0, 1, 1000, out bytes);
                        }
                    }
                    else
                    {
                        if (Class1.Serialport.IsOpen)
                        {

                            Class1.Serialport.Write(new byte[] { Convert.ToByte(i) }, 0, 1);
                        }
                    }
                    
                }

                printer_fun.Print_and_n_Lines_Feed_Forward(1);
                printer_fun.Underline_Settings(1);
                for (int i = 0; i < 256; i++)
                {
                    if (Class1.Usb_or_serial)
                    {
                        if (Class1.Device_reg_current!= null)
                        {
                            Class1.write.Write(new byte[] { Convert.ToByte(i) }, 0, 1, 1000, out bytes);
                        }
                    }
                    else
                    {
                        if (Class1.Serialport.IsOpen)
                        {

                            Class1.Serialport.Write(new byte[] { Convert.ToByte(i) }, 0, 1);
                        }
                    }

                }
                printer_fun.Underline_Settings(0);
                printer_fun.Print_and_n_Lines_Feed_Forward(1);
                printer_fun.Bold_Print_SpecifyCancel(1);
                for (int i = 0; i < 256; i++)
                {
                    if (Class1.Usb_or_serial)
                    {
                        if (Class1.Device_reg_current!= null)
                        {
                            Class1.write.Write(new byte[] { Convert.ToByte(i) }, 0, 1, 1000, out bytes);
                        }
                    }
                    else
                    {
                        if (Class1.Serialport.IsOpen)
                        {

                            Class1.Serialport.Write(new byte[] { Convert.ToByte(i) }, 0, 1);
                        }
                    }

                }
                printer_fun.Bold_Print_SpecifyCancel(0);
                printer_fun.Print_and_n_Lines_Feed_Forward(1);
                printer_fun.Reverse_Print_SpecifyCancel(1);
                for (int i = 0; i < 256; i++)
                {
                    if (Class1.Usb_or_serial)
                    {
                        if (Class1.Device_reg_current!= null)
                        {
                            Class1.write.Write(new byte[] { Convert.ToByte(i) }, 0, 1, 1000, out bytes);
                        }
                    }
                    else
                    {
                        if (Class1.Serialport.IsOpen)
                        {

                            Class1.Serialport.Write(new byte[] { Convert.ToByte(i) }, 0, 1);
                        }
                    }

                }
                printer_fun.Print_and_n_Lines_Feed_Forward(5);
                printer_fun.Reverse_Print_SpecifyCancel(0);
                printer_fun.Paper_Cut_Position_Feed(0);
           
        }

        private void automaticStatusBackEnableDisableToolStripMenuItem_Click(object sender, EventArgs e)
        {
            

            //printer_fun.Print_and_Feed_Forward(30);
        }
        
        private void bitImageModePrintToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                byte[] data = new byte[(430)];
                //ArrayList data = new ArrayList();
                bool forward = true;
                for (int i = 0; i < 430; i++)
                {
                    if (i % 5 == 0)
                    {
                        forward = !forward;

                    }
                    if (forward)
                    {
                        data[i] = 0x0F;
                    }
                    else
                    {
                        data[i] = 0xF0;
                    }




                }
                printer_fun.Bit_Image_Mode_Print(0, data.Length, data);
                printer_fun.Print_and_n_Lines_Feed_Forward(5);
            }
        }


        public event EventHandler evtdo_refresh;
        public event EventHandler evtdo_end;
        public void dosomeway()
        {
            evtdo_refresh(this, EventArgs.Empty);
        }
        public void stopdosomeway()
        {
            evtdo_end(this, EventArgs.Empty);
        }

        string automaticStatusBack_string="";
        private void enableToolStripMenuItem_Click(object sender, EventArgs e)
        {
                Class2.Show_status.notifyIcon1.Visible = true;
                evtdo_end += new EventHandler(printer_test.Class2.Show_status.toenddata);
                evtdo_refresh += new EventHandler(printer_test.Class2.Show_status.tomovedata);
                printer_fun.evt_receivechar += new printer_test.Class1.string_hander(automaticStatusBack);
                if (into_show_status == 0)
                {
                    printer_test.Class2.Show_status.Show();
                    into_show_status = 1;
                }
                printer_test.Class2.Show_status.Hide();
                //printer_test.Class2.Show_status.Visible = true;
                enableToolStripMenuItem.Enabled = false;
                disableToolStripMenuItem.Enabled = true; 
                printer_fun.Print_and_Feed_Forward(1);
           
        }
        
        private void disableToolStripMenuItem_Click(object sender, EventArgs e)
        {
                Class2.Show_status.notifyIcon1.Visible = false;
                evtdo_end -= new EventHandler(printer_test.Class2.Show_status.toenddata);
                evtdo_refresh -= new EventHandler(printer_test.Class2.Show_status.tomovedata);
                printer_fun.evt_receivechar -= new Class1.string_hander(automaticStatusBack);
                printer_test.Class2.Show_status.Visible = false;

                disableToolStripMenuItem.Enabled = false;
                enableToolStripMenuItem.Enabled = true;

                automaticStatusBack_string = "";
                //if (into_show_status == 1)
                //{
                //    printer_test.Class2.Show_status.Close();
                //    into_show_status = 0;
                //}
        }
        private void automaticStatusBack(object s, stringeventargs e)
        {
            automaticStatusBack_string += e.Get_string;
            char[] automaticStatusBack_char=automaticStatusBack_string.ToCharArray();
            if (automaticStatusBack_char.Length == 4 && (Convert.ToByte(automaticStatusBack_char[0])&16)==16)
            {
                automaticStatusBack_char_display(automaticStatusBack_char);
               // printer_test.Class2.Show_status.Visible=true;
                automaticStatusBack_string = "";
            }
            else
            {
                automaticStatusBack_string = "";
            }
            
        }
        int into_show_status = 0;
        private void automaticStatusBack_char_display(char[] x)
        {

            
            byte firstbyte = Convert.ToByte(x[0]);
            byte secondbyte = Convert.ToByte(x[1]);
            byte thirdbyte = Convert.ToByte(x[2]);
            byte fourthbyte = Convert.ToByte(x[3]);
            byte mask0 = 1;
            byte mask1 = 2;
            byte mask2= 4;
            byte mask3 = 8;
            //byte mask4 = 16;
            byte mask5= 32;
            byte mask6 = 64;
            //byte mask7 = 128;

            if ((firstbyte & mask1) == mask1)
            {
                //Class2.Show_status.label17.Text = "Work";
                Class3.Status1 = "Work";
            }
            else
            {
                //Class2.Show_status.label17.Text = "Stop";
                Class3.Status1 = "Stop";
            }
            if ((firstbyte & mask2) == mask2)
            {
                Class3.Status2 = "High";
            }
            else
            {
                Class3.Status2 = "Low";
            }

            if ((firstbyte & mask5) == mask5)
            {
                Class3.Status3 = "Opened";
            }
            else
            {
                Class3.Status3 = "Close";
            }
            if ((firstbyte & mask6) == mask6)
            {
                Class3.Status4 = "On";
            }
            else
            {
                Class3.Status4 = "Off";
            }

            //////////////////////////////////////////////
            if ((secondbyte & mask2) == mask2)
            {
                Class3.Status5 = "Yes";
            }
            else
            {
                Class3.Status5 = "No";
            }
            if ((secondbyte & mask3) == mask3)
            {
                Class3.Status6 = "Yes";
            }
            else
            {
                Class3.Status6 = "No";
            }
            if ((secondbyte & mask5) == mask5)
            {
                Class3.Status7 = "Yes";
            }
            else
            {
                Class3.Status7 = "No";
            }
            if ((secondbyte & mask6) == mask6)
            {
                Class3.Status8 = "Yes";
            }
            else
            {
                Class3.Status8 = "No";
            }
            ////////////////////////////////////////////////
            if ((thirdbyte & mask0) == mask0)
            {
                Class3.Status9 = "No pa";
            }
            else
            {
                Class3.Status9= "Yes pa";
            }
            if ((thirdbyte & mask2) == mask2)
            {
                Class3.Status10= "No pa";
            }
            else
            {
                Class3.Status10 = "Yes pa";
            }
            if ((thirdbyte & mask6) == mask6)
            {
                Class3.Status11 = "Yes";
            }
            else
            {
                Class3.Status11 = "No";
            }
            /////////////////////////////////////////////////
            if ((fourthbyte & mask0) == mask0)
            {
                Class3.Status12 = "Yes pa";
            }
            else
            {
                Class3.Status12 = "No pa";
            }
            if ((fourthbyte & mask2) == mask2)
            {
                Class3.Status13 = "Yes";
            }
            else
            {
                Class3.Status13 = "No";
            }
            if ((fourthbyte & mask5) == mask5)
            {
                Class3.Status14 = "Yes";
            }
            else
            {
                Class3.Status14 = "No";
            }
            //////////////////////////////////////////////
            if (Convert.ToInt16(x[0]) == 16 && Convert.ToInt16(x[1]) == 0 && Convert.ToInt16(x[2]) == 0 && Convert.ToInt16(x[3]) == 0)
            {
                stopdosomeway();
            }
            else
            {
                dosomeway();
            }

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form6 aboutform = new Form6();
            if (aboutform.ShowDialog() == DialogResult.OK)
            {
                aboutform.Close();
            }
        }

        private void characterRightSpaceAmountSetToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                Form7 space = new Form7();
                if (space.ShowDialog(this) == DialogResult.OK)
                {
                    printer_fun.Character_Right_Space_Amount_Set(Class3.Space);
                }
            }
        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ////string_to_print x = new string_to_print();
            ////string_status s=new string_status();
            ////x.serial_port_open("COM1", 115200, System.IO.Ports.Handshake.XOnXOff);
            ////x.print_status_set(s);
            ////bool r = s.Rotate;
            ////s.Reverse=true;
            ////x.print_chinese(s,"南京資訊股份有限公司");
            //////string_status s = new string_status();
            ////x.print_status_init();
            ////x.print_chinese( "南京資訊股份有限公司");
            //int bytesWritten;
            //for (int i = 0; i < 36; i++)
            //{
            //    if (Class1.Usb_or_serial)
            //    {
            //        if (Class1.Device_reg_current != null)
            //        {
            //            Class1.write.Write(new byte[] { Convert.ToByte("=") }, 0, 1, 1000, out bytesWritten);
            //        }
            //    }
            //}


            //Class1.write.Write(new byte[] { 0X0D }, 0, 1, 1000, out bytesWritten);
           //printer_fun.Barcode_Print_code_39("01234567890");
           // printer_fun.Print_and_Feed_Forward(50);
            
      


        }
        private void gogogo()
        {
            
            //printer_fun.Downloaded_Character_Registration(3, "南京資訊股份有限公司");
        }

        private void 中文字列印ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current!= null)
            {
                Form8 chinese = new Form8();
                if (chinese.ShowDialog(this) == DialogResult.OK)
                {



                    if (chinese.textBox1.Text != "")
                    {
                        printer_fun.Downloaded_Character_Registration(3, chinese.textBox1.Text);
                        printer_fun.Downloaded_Character_Set_SpecifyCancel(1);
                        if (Class3.Right_Left)
                        {
                            printer_fun.Alignment(2);

                            for (int i = chinese.textBox1.Text.Length-1; i>=0; i--)
                            {
                                if (Class1.Usb_or_serial)
                                {
                                    if (Class1.Device_reg_current != null)
                                    {
                                        int bytes;
                                        Class1.write.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1, 1000, out bytes);
                                    }
                                }
                                else
                                {
                                    if (Class1.Serialport.IsOpen)
                                    {

                                        Class1.Serialport.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1);
                                    }
                                }


                            }
                            

                        }
                        else
                        {
                            for (int i = 0; i < chinese.textBox1.Text.Length; i++)
                            {
                                if (Class1.Usb_or_serial)
                                {
                                    if (Class1.Device_reg_current != null)
                                    {
                                        int bytes;
                                        Class1.write.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1, 1000, out bytes);
                                    }
                                }
                                else
                                {
                                    if (Class1.Serialport.IsOpen)
                                    {

                                        Class1.Serialport.Write(new byte[] { Convert.ToByte((Convert.ToInt16(0x20) + i)) }, 0, 1);
                                    }
                                }


                            }
                        }


                        printer_fun.Downloaded_Character_Set_SpecifyCancel(0);
                        printer_fun.Alignment(0);
                        printer_fun.Print_and_n_Lines_Feed_Forward(0);
                    }

                }
            }
        }

        private void character90RightRotateSpecifyCancelToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            //SolidBrush solidBrush = new SolidBrush(Color.Black);

            //FontFamily[] fontFamilies;
            //PrivateFontCollection privateFontCollection = new PrivateFontCollection();
            //privateFontCollection.AddFontFile("D:\\Hebrew.ttf");
            //fontFamilies = privateFontCollection.Families;
            //Graphics myg = e.Graphics;

            //Font regFont = new Font(fontFamilies[0].Name, 16, FontStyle.Regular, GraphicsUnit.Pixel);
            //for (int i = 0; i < 256; i++)
            //{
            //    myg.DrawString("ñ ה ש א ₧", regFont, solidBrush, 400, 400);
            //}
        }

        private void imageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
        }

        private void imageToolStripMenuItem_DropDownOpened(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex=1;

        }

        private void strToolStripMenuItem_DropDownOpened(object sender, EventArgs e)
        {
            tabControl1.SelectedIndex = 0;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Class2.Show_status.notifyIcon1.Visible = false;
        }

        private void usbPortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            Form11 usbform = new Form11();

            if (Class1.Device_reg_current == null)
            {
                if (usbform.ShowDialog(this) == DialogResult.OK)
                {

                    Class1.Device_reg_current.Device.Open();

                    //byte[] buf = new byte[] { 0 };
                    //byte bCfgValue;

                    //bool bRtn = Class1.Device_reg_current.Device.GetConfiguration(out bCfgValue);
                    //if (bRtn)
                    //{
                    //    if (bCfgValue != 1)
                    //    {
                    //        Class1.Device_reg_current.Device.SetConfiguration(1);
                    //    }
                    //    else
                    //    {
                    //        Class1.Device_reg_current.Device.SetConfiguration(0);
                    //        Class1.Device_reg_current.Device.SetConfiguration(1);
                    //    }

                    //    if (Class1.Device_reg_current.Device is LibUsbDevice) bRtn = ((LibUsbDevice)Class1.Device_reg_current.Device).ClaimInterface(0);
                    //}

                    printer_fun.Init_local_usbport();
                }
            }
            else
            {
                if (Class1.Device_reg_current.Device.IsOpen== true)
                {
                    if (MessageBox.Show("Already Open. ", " Want To Stop?", MessageBoxButtons.YesNo, MessageBoxIcon.Stop) == DialogResult.Yes)
                    {
                        
                        Class1.Device_reg_current.Device.Close();
                        Class1.Device_reg_current = null;
                    }
                }
                else
                {
                    if (usbform.ShowDialog(this) == DialogResult.OK)
                    {
                        Class1.Device_reg_current.Device.Open();
                        printer_fun.Init_local_usbport();
                        Class1.Usb_or_serial = true;
                    }
                }
            }
            
        }

        private void barcodePrintToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Class1.Serialport.IsOpen == true || Class1.Device_reg_current != null)
            {
                Form14 barcode = new Form14();
                if (barcode.ShowDialog(this) == DialogResult.OK)
                {
                    if (barcode.textBox1.Text != "")
                    {
                        printer_fun.Barcode_Height_Set(Class3.Barcode_Height);
                        printer_fun.Barcode_Horizontal_Size_Set(Class3.Barcode_Horizontal);
                        printer_fun.HRI_Character_Print_Position_Selection(Class3.Barcode_Positiion);
                        printer_fun.Barcode_Print(Class3.Barcode_System, barcode.textBox1.Text);
                    }
                }
            }

        }

             
    }
}
